angular.module('metro-romance')

    .config(function ($stateProvider, $urlRouterProvider, $ionicConfigProvider) {

        $ionicConfigProvider.tabs.position('bottom').style('standard');

        // Ionic uses AngularUI Router which uses the concept of states
        // Learn more here: https://github.com/angular-ui/ui-router
        // Set up the various states which the app can be in.
        // Each state's controller can be found in controllers.js
        $stateProvider
            .state('select', {
                url: '/select',
                templateUrl: 'view/select/select.html',
                controller: 'SelectCtrl',
                controllerAs: 'vm'
            })
            .state('gallery', {
                url: '/gallery',
                templateUrl: 'view/gallery/gallery.html',
                controller: 'GalleryCtrl',
                controllerAs: 'vm'
            })
            .state('tutorial', {
                url: '/tutorial',
                cache: false,
                templateUrl: 'view/tutorial/tutorial.html',
                controller: 'TutorialCtrl',
                controllerAs: 'vm'
            })
            
            .state('setting', {
                url: '/setting',
                templateUrl: 'view/setting/setting.html',
                controller: 'SettingCtrl',
                controllerAs: 'vm'
            })

            .state('login', {
                url: '/login',
                templateUrl: 'view/login/login.html',
                controller: 'LoginCtrl',
                controllerAs: 'vm'
            })            
            .state('privacyterms', {
                url: '/privacyterms',
                templateUrl: 'view/privacyterms/privacyterms.html',
                controller: 'PrivacytermsCtrl',
                controllerAs: 'vm'
            })
            
            .state('ks-main', {
                url: '/ks-main',
                cache: false,
                templateUrl: 'view/main/main.html',
                controller: 'DemoCtrl',
                controllerAs: 'vm'
            })
            .state('ks-des', {
                url: '/ks-des/:id',
                cache: false,
                templateUrl: 'view/des/des.html',
                controller: 'DemoDesCtrl',
                controllerAs: 'vm'
            })
            .state('ks-items', {
                url: '/ks-items',
                cache: false,
                templateUrl: 'view/items/items.html',
                controller: 'ItemsCtrl',
                controllerAs: 'vm'
            })
            .state('ks-taskbook', {
                url: '/ks-taskbook',
                cache: false,
                templateUrl: 'view/taskbook/taskbook.html',
                controller: 'TaskbookCtrl',
                controllerAs: 'vm'
            });
        /*
        .state('tabs', {
            url: '/tabs',
            abstract: true,
            templateUrl: 'view//ks/tabs.html'
        })
        .state('tabs.taskbook', {
            url: '/taskbook',
            views: {
                'taskbook-tab': {
                    templateUrl: 'view//ks/taskbook.html',
                    controller: 'TaskbookCtrl',
                    controllerAs: 'vm'
                }
            }
        })
        .state('tabs.badge', {
            url: '/badge',
            views:{
                'badge-tab':{
            templateUrl: 'view//ks/badge.html',
            controller: 'BadgeCtrl',
            controllerAs: 'vm'
                }
            }
        })
        */


        // if none of the above states are matched, use this as the fallback
        $urlRouterProvider.otherwise('/select');

    });