angular.module('metro-romance')

    .factory('ApiService', function ($http, $q, $cordovaDevice) {

        var CODE = "3dZrj";

        return {
            /*
            getLocations: function () {
                var params = {
                    code: CODE
                }
                return $http.get('https://serene-cliffs-10627.herokuapp.com/location', { params: params })
            },
*/
            checkLocation: function (lat, lon, range) {
                var params = {
                    latitude: lat,
                    longitude: lon,
                    range: range,
                    code: CODE
                }
                return $http.get('http://serene-cliffs-10627.herokuapp.com/checkLocation', { params: params })
            },
            /*
                        getMission: function (locationID, userData) {
                            var params = {
                                locationID: locationID,
                                complete_missions: userData.mission,
                                code: CODE
                            }
                            return $http.post('https://serene-cliffs-10627.herokuapp.com/mission', params)
                        },
            
                        getUserData: function () {
                            var uuid = $cordovaDevice.getUUID();
                            console.log('uuid', uuid);
            
                            var data = {
                                deviceId: uuid,
                                code: CODE
                            }
                            return $http.post('http://serene-cliffs-10627.herokuapp.com/user_data', data)
                        },
            
                        updateUserData: function (userData) {
                            userData.deviceId = $cordovaDevice.getUUID();
                            var data = {
                                User: userData,
                                code: CODE
                            };
                            return $http.post('http://serene-cliffs-10627.herokuapp.com/update_user', data)
                        },
            */
            getAllItems: function () {
                var params = {
                    code: CODE
                }
                return $http.get('https://serene-cliffs-10627.herokuapp.com/items', { params: params });
            },

            getAllNotifications: function () {
                var params = {
                    code: CODE
                }
                return $http.get('http://serene-cliffs-10627.herokuapp.com/missiontips', { params: params });
            },

            // mock
            getUserData: function () {
                var mock = angular.fromJson({
                    "User": {
                        "loginId": "",
                        "deviceId": "12345-12345-123",
                        "name": "Jayson",
                        "gobi": 0,
                        "vibe": {
                            "Sora": 29,
                            "Emilia": 30,
                            "Nana": 25,
                            "Ann": 27,
                            "Art": 99,
                            "Feiyong": 20
                        },
                        "mission": [

                        ],
                        "item": [{
                            "ID": "0001",
                            "Count": 1
                        }, {
                            "ID": "0002",
                            "Count": 1
                        }, {
                            "ID": "0003",
                            "Count": 1
                        },
                        {
                            "ID": "0013",
                            "Name": "彈珠汽水瓶",
                            "Description": "清涼的汽水喝光後剩下的綠色玻璃瓶，搖晃時瓶頸的彈珠會發出清脆的聲音。",
                            "Count": 1
                        }
                        ],
                        "reward": ["Art", "Ann", "Sora"],
                        "badge": [],
                        "taskbook": ["KSM0001", "KSM0002", "KSM0014", "KSM0015"],
                        "event": []
                    }
                })
                var deferred = $q.defer();
                setTimeout(function () {
                    return deferred.resolve({ data: mock });
                }, 1000);
                return deferred.promise;
            },

            getRandomMission: function () {

                var mock = angular.fromJson({
                    "R0001": {
                        "question": [
                            {
                                "type": "dialogue",
                                "character": "雅朵",
                                "facial_exp": "Art_shock.png",
                                "dialogue": "奇怪？我剛才隨手放在旁邊的東西呢？",
                                "effect_obj": ""
                            }
                        ],
                        "character": [
                            "Art"
                        ],
                        "select": {
                            "0003": [
                                {
                                    "type": "dialogue",
                                    "character": "雅朵",
                                    "facial_exp": "Art_happy.png",
                                    "dialogue": "啊！謝謝你！要是弄丟了我會很著急的。",
                                    "effect_obj": ""
                                },
                                {
                                    "type": "dialogue",
                                    "character": "我",
                                    "facial_exp": "Me_.png",
                                    "dialogue": "雅朵比我想像中的還迷糊啊。",
                                    "effect_obj": ""
                                },
                                {
                                    "type": "dialogue",
                                    "character": "雅朵",
                                    "facial_exp": "Art_happy.png",
                                    "dialogue": "是因為......你很可靠啊，所以和你在一起我就有些太放鬆了......",
                                    "effect_obj": {
                                        "type": "update_vibe",
                                        "target": {
                                            "Art": 10
                                        }
                                    }
                                }
                            ],
                            "0009": [
                                {
                                    "type": "dialogue",
                                    "character": "雅朵",
                                    "facial_exp": "Art_happy.png",
                                    "dialogue": "是哈比玩偶～好可愛喔～",
                                    "effect_obj": ""
                                },
                                {
                                    "type": "dialogue",
                                    "character": "我",
                                    "facial_exp": "Me_.png",
                                    "dialogue": "這個送給你吧。",
                                    "effect_obj": ""
                                },
                                {
                                    "type": "dialogue",
                                    "character": "雅朵",
                                    "facial_exp": "Art_happy.png",
                                    "dialogue": "真的嗎？謝謝！",
                                    "effect_obj": {
                                        "type": "update_vibe",
                                        "target": {
                                            "Art": 5
                                        }
                                    }
                                }
                            ],
                            "0002": [
                                {
                                    "type": "dialogue",
                                    "character": "雅朵",
                                    "facial_exp": "Art_normal.png",
                                    "dialogue": "這個......好像在飛揚的辦公桌上看過。",
                                    "effect_obj": {
                                        "type": "update_vibe",
                                        "target": {
                                            "Art": 0
                                        }
                                    }
                                }
                            ],
                            "other": [
                                {
                                    "type": "dialogue",
                                    "character": "雅朵",
                                    "facial_exp": "Art_shock.png",
                                    "dialogue": "不是耶，這不是我的東西。",
                                    "effect_obj": {
                                        "type": "update_vibe",
                                        "target": {
                                            "Art": 0
                                        }
                                    }
                                }
                            ],
                            "exit": [
                                {
                                    "type": "dialogue",
                                    "character": "雅朵",
                                    "facial_exp": "Art_sad.png",
                                    "dialogue": "是嗎.... 好吧。我再來找找。到底放哪裡了呢....",
                                    "effect_obj": {
                                        "type": "update_vibe",
                                        "target": {
                                            "Art": 0
                                        }
                                    }
                                }
                            ],
                            "0001": [
                                {
                                    "type": "dialogue",
                                    "character": "雅朵",
                                    "facial_exp": "Art_shock.png",
                                    "dialogue": "這是要給我的嗎？",
                                    "effect_obj": {
                                        "type": "update_vibe",
                                        "target": {
                                            "Art": 15
                                        }
                                    }
                                },
                                {
                                    "type": "dialogue",
                                    "character": "我",
                                    "facial_exp": "Me_undefined.png",
                                    "dialogue": "（沒錯，請你收下它⋯⋯）",
                                    "effect_obj": ""
                                },
                                {
                                    "type": "dialogue",
                                    "character": "雅朵",
                                    "facial_exp": "Art_normal.png",
                                    "dialogue": "裏頭寫的東西，不論思量琢磨了多久，其實只是一句簡單的提問吧？",
                                    "effect_obj": ""
                                },
                                {
                                    "type": "dialogue",
                                    "character": "我",
                                    "facial_exp": "Me_undefined.png",
                                    "dialogue": "（雅朵接下了信封，突然意識到正和我四目相交的她，害羞地將視線往下。）",
                                    "effect_obj": ""
                                },
                                {
                                    "type": "dialogue",
                                    "character": "雅朵",
                                    "facial_exp": "Art_normal.png",
                                    "dialogue": "就是在問對方有沒有把自己放在心中——",
                                    "effect_obj": ""
                                },
                                {
                                    "type": "dialogue",
                                    "character": "我",
                                    "facial_exp": "Me_undefined.png",
                                    "dialogue": "所以⋯⋯",
                                    "effect_obj": ""
                                },
                                {
                                    "type": "dialogue",
                                    "character": "雅朵",
                                    "facial_exp": "Art_happy.png",
                                    "dialogue": "我跟你說⋯⋯因為我們有共同的愛好啊，所以我常常會想起你呢。",
                                    "effect_obj": ""
                                },
                                {
                                    "type": "dialogue",
                                    "character": "雅朵",
                                    "facial_exp": "Art_happy.png",
                                    "dialogue": "我一直都很珍惜和你相遇的時光，希望你在旅行時候，也能夠想起我。",
                                    "effect_obj": ""
                                }
                            ]
                        }
                    },
                    "R0002": {
                        "question": [
                            {
                                "type": "dialogue",
                                "character": "飛揚",
                                "facial_exp": "Feiyong_normal.png",
                                "dialogue": "最近想出門走走，你有什麼建議嗎？",
                                "effect_obj": ""
                            }
                        ],
                        "character": [
                            "Feiyong"
                        ],
                        "select": {
                            "0002": [
                                {
                                    "type": "dialogue",
                                    "character": "飛揚",
                                    "facial_exp": "Feiyong_happy.png",
                                    "dialogue": "喔喔！你對棒球也有興趣嗎？",
                                    "effect_obj": ""
                                },
                                {
                                    "type": "dialogue",
                                    "character": "飛揚",
                                    "facial_exp": "Feiyong_happy.png",
                                    "dialogue": "既然如此我們一塊去打球吧！",
                                    "effect_obj": ""
                                },
                                {
                                    "type": "dialogue",
                                    "character": "我",
                                    "facial_exp": "Me_.png",
                                    "dialogue": "不過我在這方面沒有很在行......",
                                    "effect_obj": ""
                                },
                                {
                                    "type": "dialogue",
                                    "character": "飛揚",
                                    "facial_exp": "Feiyong_happy.png",
                                    "dialogue": "沒關係！一回生二回熟嘛，我可以教你！",
                                    "effect_obj": {
                                        "type": "update_vibe",
                                        "target": {
                                            "Feiyong": 10
                                        }
                                    }
                                }
                            ],
                            "0009": [
                                {
                                    "type": "dialogue",
                                    "character": "我",
                                    "facial_exp": "Me_.png",
                                    "dialogue": "哈比說跟我一起留在家裡別出去了。",
                                    "effect_obj": ""
                                },
                                {
                                    "type": "dialogue",
                                    "character": "飛揚",
                                    "facial_exp": "Feiyong_normal.png",
                                    "dialogue": "如果哈比來我家的話，我就跟哈比待在家裡。",
                                    "effect_obj": ""
                                },
                                {
                                    "type": "dialogue",
                                    "character": "我",
                                    "facial_exp": "Me_.png",
                                    "dialogue": "......好吧，那這隻就送給你吧。",
                                    "effect_obj": ""
                                },
                                {
                                    "type": "dialogue",
                                    "character": "飛揚",
                                    "facial_exp": "Feiyong_happy.png",
                                    "dialogue": "耶！謝謝你！",
                                    "effect_obj": {
                                        "type": "update_vibe",
                                        "target": {
                                            "Feiyong": 5
                                        }
                                    }
                                }
                            ],
                            "0003": [
                                {
                                    "type": "dialogue",
                                    "character": "飛揚",
                                    "facial_exp": "Feiyong_normal.png",
                                    "dialogue": "這個手帳本很有雅朵的風格......",
                                    "effect_obj": {
                                        "type": "update_vibe",
                                        "target": {
                                            "Feiyong": 0
                                        }
                                    }
                                }
                            ],
                            "other": [
                                {
                                    "type": "dialogue",
                                    "character": "飛揚",
                                    "facial_exp": "Feiyong_sad.png",
                                    "dialogue": "哎......還是沒有靈感呢。",
                                    "effect_obj": {
                                        "type": "update_vibe",
                                        "target": {
                                            "Feiyong": 0
                                        }
                                    }
                                }
                            ]
                        }
                    },
                    "R0003": {
                        "question": [
                            {
                                "type": "dialogue",
                                "character": "小穹",
                                "facial_exp": "Sora_sad.png",
                                "dialogue": "嗯......總覺得應該來吃個點心。",
                                "effect_obj": ""
                            }
                        ],
                        "character": [
                            "Sora"
                        ],
                        "select": {
                            "0007": [
                                {
                                    "type": "dialogue",
                                    "character": "我",
                                    "facial_exp": "Me_.png",
                                    "dialogue": "要不要吃我剛買的小蛋糕？",
                                    "effect_obj": ""
                                },
                                {
                                    "type": "dialogue",
                                    "character": "小穹",
                                    "facial_exp": "Sora_shock.png",
                                    "dialogue": "喔喔！是蛋糕！！",
                                    "effect_obj": ""
                                },
                                {
                                    "type": "dialogue",
                                    "character": "小穹",
                                    "facial_exp": "Sora_happy.png",
                                    "dialogue": "太謝謝你了！",
                                    "effect_obj": {
                                        "type": "update_vibe",
                                        "target": {
                                            "Sora": 10
                                        }
                                    }
                                }
                            ],
                            "0006": [
                                {
                                    "type": "dialogue",
                                    "character": "小穹",
                                    "facial_exp": "Sora_normal.png",
                                    "dialogue": "肚子餓的時候喝茶，會更難受的！",
                                    "effect_obj": {
                                        "type": "update_vibe",
                                        "target": {
                                            "Sora": 0
                                        }
                                    }
                                }
                            ],
                            "0008": [
                                {
                                    "type": "dialogue",
                                    "character": "我",
                                    "facial_exp": "Me_.png",
                                    "dialogue": "不行～要忍住，不然泰迪會生氣的。",
                                    "effect_obj": ""
                                },
                                {
                                    "type": "dialogue",
                                    "character": "小穹",
                                    "facial_exp": "Sora_sad.png",
                                    "dialogue": "也是......剛剛才吃過零食的，這樣泰迪會不會鄙視我。",
                                    "effect_obj": ""
                                },
                                {
                                    "type": "dialogue",
                                    "character": "我",
                                    "facial_exp": "Me_.png",
                                    "dialogue": "那就讓泰迪待在你身邊監督你吧～",
                                    "effect_obj": ""
                                },
                                {
                                    "type": "dialogue",
                                    "character": "小穹",
                                    "facial_exp": "Sora_happy.png",
                                    "dialogue": "哇啊～謝謝！我會努力撐下去的，泰迪！",
                                    "effect_obj": {
                                        "type": "update_vibe",
                                        "target": {
                                            "Sora": 5
                                        }
                                    }
                                }
                            ],
                            "other": [
                                {
                                    "type": "dialogue",
                                    "character": "小穹",
                                    "facial_exp": "Sora_sad.png",
                                    "dialogue": "這個不能吃吧！",
                                    "effect_obj": {
                                        "type": "update_vibe",
                                        "target": {
                                            "Sora": 0
                                        }
                                    }
                                }
                            ]
                        }
                    },
                    "R0004": {
                        "question": [
                            {
                                "type": "dialogue",
                                "character": "艾米莉亞",
                                "facial_exp": "Emilia_normal.png",
                                "dialogue": "啊......在工作之間的空擋剛好可以休息一下。有沒有什麼放鬆的好點子呢？",
                                "effect_obj": ""
                            }
                        ],
                        "character": [
                            "Emilia"
                        ],
                        "select": {
                            "0006": [
                                {
                                    "type": "dialogue",
                                    "character": "我",
                                    "facial_exp": "Me_.png",
                                    "dialogue": "喝杯麥茶吧，能夠平靜心情噢。",
                                    "effect_obj": ""
                                },
                                {
                                    "type": "dialogue",
                                    "character": "艾米莉亞",
                                    "facial_exp": "Emilia_normal.png",
                                    "dialogue": "啊！我剛剛也是這麼想！",
                                    "effect_obj": ""
                                },
                                {
                                    "type": "dialogue",
                                    "character": "艾米莉亞",
                                    "facial_exp": "Emilia_happy.png",
                                    "dialogue": "太好了，能認識也喜歡麥茶的同好～",
                                    "effect_obj": {
                                        "type": "update_vibe",
                                        "target": {
                                            "Emilia": 10
                                        }
                                    }
                                }
                            ],
                            "0005": [
                                {
                                    "type": "dialogue",
                                    "character": "我",
                                    "facial_exp": "Me_.png",
                                    "dialogue": "聽個音樂呢？",
                                    "effect_obj": ""
                                },
                                {
                                    "type": "dialogue",
                                    "character": "艾米莉亞",
                                    "facial_exp": "Emilia_shock.png",
                                    "dialogue": "這種類型......不是我平常愛聽的耶。",
                                    "effect_obj": {
                                        "type": "update_vibe",
                                        "target": {
                                            "Emilia": 0
                                        }
                                    }
                                }
                            ],
                            "0007": [
                                {
                                    "type": "dialogue",
                                    "character": "我",
                                    "facial_exp": "Me_.png",
                                    "dialogue": "吃點甜食如何？",
                                    "effect_obj": ""
                                },
                                {
                                    "type": "dialogue",
                                    "character": "艾米莉亞",
                                    "facial_exp": "Emilia_shock.png",
                                    "dialogue": "不行！這樣會變胖的！！",
                                    "effect_obj": {
                                        "type": "update_vibe",
                                        "target": {
                                            "Emilia": 0
                                        }
                                    }
                                }
                            ],
                            "0008": [
                                {
                                    "type": "dialogue",
                                    "character": "我",
                                    "facial_exp": "Me_.png",
                                    "dialogue": "我最近很喜歡蒐集這種小東西。",
                                    "effect_obj": ""
                                },
                                {
                                    "type": "dialogue",
                                    "character": "艾米莉亞",
                                    "facial_exp": "Emilia_normal.png",
                                    "dialogue": "這系列我知道！休息的時候看著它超療癒的～",
                                    "effect_obj": ""
                                },
                                {
                                    "type": "dialogue",
                                    "character": "我",
                                    "facial_exp": "Me_.png",
                                    "dialogue": "要不然這個送給你吧。",
                                    "effect_obj": ""
                                },
                                {
                                    "type": "dialogue",
                                    "character": "艾米莉亞",
                                    "facial_exp": "Emilia_happy.png",
                                    "dialogue": "真的嗎？謝謝你！",
                                    "effect_obj": {
                                        "type": "update_vibe",
                                        "target": {
                                            "Emilia": 5
                                        }
                                    }
                                }
                            ],
                            "other": [
                                {
                                    "type": "dialogue",
                                    "character": "艾米莉亞",
                                    "facial_exp": "Emilia_sad.png",
                                    "dialogue": "這好像沒什麼用......",
                                    "effect_obj": {
                                        "type": "update_vibe",
                                        "target": {
                                            "Emilia": 0
                                        }
                                    }
                                }
                            ]
                        }
                    },
                    "R0005": {
                        "question": [
                            {
                                "type": "dialogue",
                                "character": "婕兒",
                                "facial_exp": "Ann_sad.png",
                                "dialogue": "我口袋裡的東西好像剛才掉出來了，你有沒有撿到啊？",
                                "effect_obj": ""
                            }
                        ],
                        "character": [
                            "Ann"
                        ],
                        "select": {
                            "0004": [
                                {
                                    "type": "dialogue",
                                    "character": "我",
                                    "facial_exp": "Me_.png",
                                    "dialogue": "這個是你的吧......",
                                    "effect_obj": ""
                                },
                                {
                                    "type": "dialogue",
                                    "character": "婕兒",
                                    "facial_exp": "Ann_happy.png",
                                    "dialogue": "沒錯！那是我的！",
                                    "effect_obj": ""
                                },
                                {
                                    "type": "dialogue",
                                    "character": "婕兒",
                                    "facial_exp": "Ann_happy.png",
                                    "dialogue": "太感謝你了！",
                                    "effect_obj": ""
                                },
                                {
                                    "type": "dialogue",
                                    "character": "我",
                                    "facial_exp": "Me_.png",
                                    "dialogue": "為什麼你身上會隨身攜帶扳手......",
                                    "effect_obj": ""
                                },
                                {
                                    "type": "dialogue",
                                    "character": "婕兒",
                                    "facial_exp": "Ann_shock.png",
                                    "dialogue": "身為一個工程師，身上有隻扳手不是很正常的嗎？這樣要是得先拆——",
                                    "effect_obj": ""
                                },
                                {
                                    "type": "dialogue",
                                    "character": "我",
                                    "facial_exp": "Me_.png",
                                    "dialogue": "欸欸不要那麼大聲！大家都在看我們啦！",
                                    "effect_obj": {
                                        "type": "update_vibe",
                                        "target": {
                                            "Ann": 10
                                        }
                                    }
                                }
                            ],
                            "0008": [
                                {
                                    "type": "dialogue",
                                    "character": "我",
                                    "facial_exp": "Me_.png",
                                    "dialogue": "你掉的是這個嗎？",
                                    "effect_obj": ""
                                },
                                {
                                    "type": "dialogue",
                                    "character": "婕兒",
                                    "facial_exp": "Ann_happy.png",
                                    "dialogue": "哇！這個好可愛！",
                                    "effect_obj": ""
                                },
                                {
                                    "type": "dialogue",
                                    "character": "婕兒",
                                    "facial_exp": "Ann_sad.png",
                                    "dialogue": "但是不是我掉的......",
                                    "effect_obj": ""
                                },
                                {
                                    "type": "dialogue",
                                    "character": "我",
                                    "facial_exp": "Me_.png",
                                    "dialogue": "哈，這是我想送你的禮物啦。",
                                    "effect_obj": ""
                                },
                                {
                                    "type": "dialogue",
                                    "character": "婕兒",
                                    "facial_exp": "Ann_happy.png",
                                    "dialogue": "欸？你怎麼、你怎麼對我這麼好！",
                                    "effect_obj": ""
                                },
                                {
                                    "type": "dialogue",
                                    "character": "我",
                                    "facial_exp": "Me_.png",
                                    "dialogue": "在路上看到覺得很適合婕兒所以就買了。",
                                    "effect_obj": ""
                                },
                                {
                                    "type": "dialogue",
                                    "character": "婕兒",
                                    "facial_exp": "Ann_normal.png",
                                    "dialogue": "謝謝你～！！",
                                    "effect_obj": {
                                        "type": "update_vibe",
                                        "target": {
                                            "Ann": 5
                                        }
                                    }
                                }
                            ],
                            "other": [
                                {
                                    "type": "dialogue",
                                    "character": "婕兒",
                                    "facial_exp": "Ann_sad.png",
                                    "dialogue": "這不是我的喔。",
                                    "effect_obj": {
                                        "type": "update_vibe",
                                        "target": {
                                            "Ann": 0
                                        }
                                    }
                                }
                            ]
                        }
                    },
                    "R0006": {
                        "question": [
                            {
                                "type": "dialogue",
                                "character": "我",
                                "facial_exp": "Me_.png",
                                "dialogue": "（耐耐正哼著歌，心情似乎不錯。）要怎麼和耐耐搭話呢？",
                                "effect_obj": ""
                            }
                        ],
                        "character": [
                            "Nana"
                        ],
                        "select": {
                            "0005": [
                                {
                                    "type": "dialogue",
                                    "character": "我",
                                    "facial_exp": "Me_.png",
                                    "dialogue": "我最近買了這張CD，覺得很不錯。",
                                    "effect_obj": ""
                                },
                                {
                                    "type": "dialogue",
                                    "character": "耐耐",
                                    "facial_exp": "Nana_normal.png",
                                    "dialogue": "欸？你也是他們的歌迷？！",
                                    "effect_obj": ""
                                },
                                {
                                    "type": "dialogue",
                                    "character": "我",
                                    "facial_exp": "Me_.png",
                                    "dialogue": "對呀，不過我從最近才開始聽的啦。",
                                    "effect_obj": ""
                                },
                                {
                                    "type": "dialogue",
                                    "character": "耐耐",
                                    "facial_exp": "Nana_normal.png",
                                    "dialogue": "沒想到你居然能搶到這次的限定專輯......",
                                    "effect_obj": ""
                                },
                                {
                                    "type": "dialogue",
                                    "character": "我",
                                    "facial_exp": "Me_.png",
                                    "dialogue": "不然先借你聽吧。",
                                    "effect_obj": ""
                                },
                                {
                                    "type": "dialogue",
                                    "character": "耐耐",
                                    "facial_exp": "Nana_happy.png",
                                    "dialogue": "真的？謝謝你～",
                                    "effect_obj": {
                                        "type": "update_vibe",
                                        "target": {
                                            "Nana": 5
                                        }
                                    }
                                }
                            ],
                            "0004": [
                                {
                                    "type": "dialogue",
                                    "character": "我",
                                    "facial_exp": "Me_.png",
                                    "dialogue": "我剛才在地上撿到這個......",
                                    "effect_obj": ""
                                },
                                {
                                    "type": "dialogue",
                                    "character": "耐耐",
                                    "facial_exp": "Nana_shock.png",
                                    "dialogue": "......",
                                    "effect_obj": ""
                                },
                                {
                                    "type": "dialogue",
                                    "character": "耐耐",
                                    "facial_exp": "Nana_shock.png",
                                    "dialogue": "這應該是婕兒弄掉的吧。",
                                    "effect_obj": {
                                        "type": "update_vibe",
                                        "target": {
                                            "Nana": 0
                                        }
                                    }
                                }
                            ],
                            "0008": [
                                {
                                    "type": "dialogue",
                                    "character": "我",
                                    "facial_exp": "Me_.png",
                                    "dialogue": "你的包包上的吊飾，跟這個是同一系列的耶。",
                                    "effect_obj": ""
                                },
                                {
                                    "type": "dialogue",
                                    "character": "耐耐",
                                    "facial_exp": "Nana_normal.png",
                                    "dialogue": "嗯......真的耶。",
                                    "effect_obj": ""
                                },
                                {
                                    "type": "dialogue",
                                    "character": "耐耐",
                                    "facial_exp": "Nana_normal.png",
                                    "dialogue": "那我不掛了。",
                                    "effect_obj": ""
                                },
                                {
                                    "type": "dialogue",
                                    "character": "我",
                                    "facial_exp": "Me_.png",
                                    "dialogue": "欸？！為什麼？",
                                    "effect_obj": ""
                                },
                                {
                                    "type": "dialogue",
                                    "character": "耐耐",
                                    "facial_exp": "Nana_happy.png",
                                    "dialogue": "開玩笑的啦。",
                                    "effect_obj": ""
                                },
                                {
                                    "type": "dialogue",
                                    "character": "我",
                                    "facial_exp": "Me_.png",
                                    "dialogue": "其實這也不是我自己在用的，本來就準備要送給你。",
                                    "effect_obj": ""
                                },
                                {
                                    "type": "dialogue",
                                    "character": "耐耐",
                                    "facial_exp": "Nana_happy.png",
                                    "dialogue": "是一對的呢......",
                                    "effect_obj": ""
                                },
                                {
                                    "type": "dialogue",
                                    "character": "耐耐",
                                    "facial_exp": "Nana_normal.png",
                                    "dialogue": "沒想到你能猜到我想搜集的花色，謝謝你～",
                                    "effect_obj": {
                                        "type": "update_vibe",
                                        "target": {
                                            "Nana": 5
                                        }
                                    }
                                }
                            ],
                            "other": [
                                {
                                    "type": "dialogue",
                                    "character": "我",
                                    "facial_exp": "Me_.png",
                                    "dialogue": "耐耐......咦？人呢？",
                                    "effect_obj": ""
                                },
                                {
                                    "type": "dialogue",
                                    "character": "我",
                                    "facial_exp": "Me_.png",
                                    "dialogue": "（耐耐在我一不注意的時候已經離開我的視線了。）",
                                    "effect_obj": {
                                        "type": "update_vibe",
                                        "target": {
                                            "Nana": 0
                                        }
                                    }
                                }
                            ]
                        }
                    }
                })
                var newMock = Object.keys(mock).map(function (objKey, index) {
                    var value = mock[objKey];
                    return {
                        character: value["character"][0],
                        question: value["question"],
                        select: value["select"],
                    }
                });
                var deferred = $q.defer();

                setTimeout(function () {
                    return deferred.resolve({ data: newMock });
                }, 1000);
                return deferred.promise;
            },

            getMission: function () {
                var mock = angular.fromJson({
                    "mission": {
                        "missionID": "KSM0003",
                        "ARimg": "Art_Feiyong_normal_ar.png",
                        "backgroundImage": "https://metroromances3.s3.amazonaws.com/d8a6c1a40745a04a461dbcf11120e179_16_Dome%20of%20Light.png",
                        "character": [
                            "Art",
                            "Feiyong"
                        ]
                    },
                    "dialog": {
                        "Low": [
                            {
                                "type": "dialogue",
                                "character": "我",
                                "facial_exp": "",
                                "dialogue": "哇！今天怎麼會這麼多人聚集在這邊呀？",
                                "branch_obj": {},
                                "effect_obj": {}
                            },
                            {
                                "type": "dialogue",
                                "character": "飛揚",
                                "facial_exp": "Feiyong_happy.png",
                                "dialogue": "你竟然忘記了！ 今天是────",
                                "branch_obj": {},
                                "effect_obj": {}
                            },
                            {
                                "type": "dialogue",
                                "character": "雅朵",
                                "facial_exp": "Art_happy.png",
                                "dialogue": "好啦... 飛揚你就不要再鬧他了....",
                                "branch_obj": {},
                                "effect_obj": {}
                            },
                            {
                                "type": "dialogue",
                                "character": "我",
                                "facial_exp": "",
                                "dialogue": "啊！我想起來了，今天是....",
                                "branch_obj": {},
                                "effect_obj": {}
                            },
                            {
                                "type": "select",
                                "select": [
                                    {
                                        "response": "我的慶生趴。",
                                        "following": [
                                            {
                                                "character": "我",
                                                "facial_exp": "",
                                                "dialogue": "啊！原來今天是我的生日呀!!!!",
                                                "branch_obj": {},
                                                "effect_obj": {}
                                            },
                                            {
                                                "character": "我",
                                                "facial_exp": "",
                                                "dialogue": "沒想到台下竟然有這麼多人來幫我慶祝，真是太感動了...",
                                                "branch_obj": {},
                                                "effect_obj": {}
                                            },
                                            {
                                                "character": "雅朵",
                                                "facial_exp": "Art_shock.png",
                                                "dialogue": "真的假的！？",
                                                "branch_obj": {},
                                                "effect_obj": {
                                                    "type": "get_item",
                                                    "targetID": "0007",
                                                    "count": 1
                                                }
                                            },
                                            {
                                                "character": "飛揚",
                                                "facial_exp": "Feiyong_shock.png",
                                                "dialogue": "什麼、雅朵你竟然忘記了呀～ 還好我有準備！",
                                                "branch_obj": {},
                                                "effect_obj": {}
                                            },
                                            {
                                                "character": "飛揚",
                                                "facial_exp": "Feiyong_happy.png",
                                                "dialogue": "給你的蛋糕，生日快樂！！！",
                                                "branch_obj": {},
                                                "effect_obj": {}
                                            },
                                            {
                                                "character": "雅朵",
                                                "facial_exp": "Art_happy.png",
                                                "dialogue": "哈、祝你生日快樂唷～～",
                                                "branch_obj": {},
                                                "effect_obj": {}
                                            }
                                        ],
                                        "effect_obj": {
                                            "type": "update_vibe",
                                            "target": {
                                                "Feiyong": 0
                                            }
                                        }
                                    },
                                    {
                                        "response": "高捷戀旅 2 的發表記者會！",
                                        "following": [
                                            {
                                                "character": "我",
                                                "facial_exp": "",
                                                "dialogue": "是遊戲的發表記者會！！！！",
                                                "branch_obj": {},
                                                "effect_obj": {}
                                            },
                                            {
                                                "character": "雅朵",
                                                "facial_exp": "Art_happy.png",
                                                "dialogue": "哈哈 對呀！ 開發了好久，終於公開啦！！！",
                                                "branch_obj": {},
                                                "effect_obj": {}
                                            },
                                            {
                                                "character": "飛揚",
                                                "facial_exp": "Feiyong_sad.png",
                                                "dialogue": "真是辛苦了高雄捷運還有開發團隊了呀...",
                                                "branch_obj": {},
                                                "effect_obj": {}
                                            },
                                            {
                                                "character": "雅朵",
                                                "facial_exp": "Art_happy.png",
                                                "dialogue": "飛揚、我怎麼覺得你眼淚要留下來了呀？",
                                                "branch_obj": {},
                                                "effect_obj": {}
                                            },
                                            {
                                                "character": "飛揚",
                                                "facial_exp": "Feiyong_happy.png",
                                                "dialogue": "總之，謝謝高雄捷運、合作的景點，還有今天來參加的各位～",
                                                "branch_obj": {},
                                                "effect_obj": {}
                                            },
                                            {
                                                "character": "雅朵",
                                                "facial_exp": "Art_happy.png",
                                                "dialogue": "謝謝你們！！！！",
                                                "branch_obj": {},
                                                "effect_obj": {
                                                    "type": "get_item",
                                                    "targetID": "0009",
                                                    "count": 1
                                                }
                                            }
                                        ],
                                        "effect_obj": {
                                            "type": "update_vibe",
                                            "target": {
                                                "Feiyong": 0
                                            }
                                        }
                                    },
                                    {
                                        "response": "高雄捷運處長的生日？",
                                        "following": [
                                            {
                                                "character": "我",
                                                "facial_exp": "",
                                                "dialogue": "是高捷的處長的生日吧！！！ 糟了，我竟然忘了...",
                                                "branch_obj": {},
                                                "effect_obj": {}
                                            },
                                            {
                                                "character": "飛揚",
                                                "facial_exp": "Feiyong_shock.png",
                                                "dialogue": "我們總之想個方法吧...",
                                                "branch_obj": {},
                                                "effect_obj": {}
                                            },
                                            {
                                                "character": "我",
                                                "facial_exp": "",
                                                "dialogue": "要送什麼呢.....?",
                                                "branch_obj": {},
                                                "effect_obj": {}
                                            },
                                            {
                                                "character": "雅朵",
                                                "facial_exp": "Art_shock.png",
                                                "dialogue": "啊！ 我想到了。我記得處長之前是工程部門的，所以也許他會喜歡這個吧！",
                                                "branch_obj": {},
                                                "effect_obj": {
                                                    "type": "get_item",
                                                    "targetID": "0004",
                                                    "count": 1
                                                }
                                            },
                                            {
                                                "character": "飛揚",
                                                "facial_exp": "Feiyong_shock.png",
                                                "dialogue": "雅朵、你怎麼會隨身攜帶扳手在身上呀！！？",
                                                "branch_obj": {},
                                                "effect_obj": {}
                                            },
                                            {
                                                "character": "雅朵",
                                                "facial_exp": "Art_happy.png",
                                                "dialogue": "先不要管這個了，我們快把禮物送給處長吧～～～",
                                                "branch_obj": {},
                                                "effect_obj": {}
                                            }
                                        ],
                                        "effect_obj": {
                                            "type": "update_vibe",
                                            "target": {
                                                "Feiyong": 0
                                            }
                                        }
                                    }
                                ]
                            },
                            {
                                "type": "dialogue",
                                "character": "我",
                                "facial_exp": "",
                                "dialogue": "謝謝大家，希望你們會喜歡這個遊戲！",
                                "branch_obj": {},
                                "effect_obj": {}
                            },
                            {
                                "type": "dialogue",
                                "character": "雅朵",
                                "facial_exp": "Art_happy.png",
                                "dialogue": "也希望大家會喜歡高雄這個美麗的城市～",
                                "branch_obj": {},
                                "effect_obj": {}
                            },
                            {
                                "type": "dialogue",
                                "character": "飛揚",
                                "facial_exp": "Feiyong_happy.png",
                                "dialogue": "還有即將和我們合作的台北以及日本福岡唷～～",
                                "branch_obj": {},
                                "effect_obj": {
                                    "type": "get_item",
                                    "targetID": "0001",
                                    "count": 1
                                }
                            },
                            {
                                "type": "dialogue",
                                "character": "雅朵",
                                "facial_exp": "Art_happy.png",
                                "dialogue": "特別任務完成記念：遊戲發表會",
                                "branch_obj": {},
                                "effect_obj": {
                                    "type": "mission_complete",
                                    "complete": "KSM0024",
                                    "vibe": "Low"
                                }
                            }
                        ],
                        "Mid": [],
                        "High":  [
                            {
                                "type": "dialogue",
                                "character": "我",
                                "facial_exp": "",
                                "dialogue": "哇！今天怎麼會這麼多人聚集在這邊呀？",
                                "branch_obj": {},
                                "effect_obj": {}
                            },
                            {
                                "type": "dialogue",
                                "character": "飛揚",
                                "facial_exp": "Feiyong_happy.png",
                                "dialogue": "你竟然忘記了！ 今天是────",
                                "branch_obj": {},
                                "effect_obj": {}
                            },
                            {
                                "type": "dialogue",
                                "character": "雅朵",
                                "facial_exp": "Art_happy.png",
                                "dialogue": "好啦... 飛揚你就不要再鬧他了....",
                                "branch_obj": {},
                                "effect_obj": {}
                            },
                            {
                                "type": "dialogue",
                                "character": "我",
                                "facial_exp": "",
                                "dialogue": "啊！我想起來了，今天是....",
                                "branch_obj": {},
                                "effect_obj": {}
                            },
                            {
                                "type": "select",
                                "select": [
                                    {
                                        "response": "我的慶生趴。",
                                        "following": [
                                            {
                                                "character": "我",
                                                "facial_exp": "",
                                                "dialogue": "啊！原來今天是我的生日呀!!!!",
                                                "branch_obj": {},
                                                "effect_obj": {}
                                            },
                                            {
                                                "character": "我",
                                                "facial_exp": "",
                                                "dialogue": "沒想到台下竟然有這麼多人來幫我慶祝，真是太感動了...",
                                                "branch_obj": {},
                                                "effect_obj": {}
                                            },
                                            {
                                                "character": "雅朵",
                                                "facial_exp": "Art_shock.png",
                                                "dialogue": "真的假的！？",
                                                "branch_obj": {},
                                                "effect_obj": {
                                                    "type": "get_item",
                                                    "targetID": "0007",
                                                    "count": 1
                                                }
                                            },
                                            {
                                                "character": "飛揚",
                                                "facial_exp": "Feiyong_shock.png",
                                                "dialogue": "什麼、雅朵你竟然忘記了呀～ 還好我有準備！",
                                                "branch_obj": {},
                                                "effect_obj": {}
                                            },
                                            {
                                                "character": "飛揚",
                                                "facial_exp": "Feiyong_happy.png",
                                                "dialogue": "給你的蛋糕，生日快樂！！！",
                                                "branch_obj": {},
                                                "effect_obj": {}
                                            },
                                            {
                                                "character": "雅朵",
                                                "facial_exp": "Art_happy.png",
                                                "dialogue": "哈、祝你生日快樂唷～～",
                                                "branch_obj": {},
                                                "effect_obj": {}
                                            }
                                        ],
                                        "effect_obj": {
                                            "type": "update_vibe",
                                            "target": {
                                                "Feiyong": 0
                                            }
                                        }
                                    },
                                    {
                                        "response": "高捷戀旅 2 的發表記者會！",
                                        "following": [
                                            {
                                                "character": "我",
                                                "facial_exp": "",
                                                "dialogue": "是遊戲的發表記者會！！！！",
                                                "branch_obj": {},
                                                "effect_obj": {}
                                            },
                                            {
                                                "character": "雅朵",
                                                "facial_exp": "Art_happy.png",
                                                "dialogue": "哈哈 對呀！ 開發了好久，終於公開啦！！！",
                                                "branch_obj": {},
                                                "effect_obj": {}
                                            },
                                            {
                                                "character": "飛揚",
                                                "facial_exp": "Feiyong_sad.png",
                                                "dialogue": "真是辛苦了高雄捷運還有開發團隊了呀...",
                                                "branch_obj": {},
                                                "effect_obj": {}
                                            },
                                            {
                                                "character": "雅朵",
                                                "facial_exp": "Art_happy.png",
                                                "dialogue": "飛揚、我怎麼覺得你眼淚要留下來了呀？",
                                                "branch_obj": {},
                                                "effect_obj": {}
                                            },
                                            {
                                                "character": "飛揚",
                                                "facial_exp": "Feiyong_happy.png",
                                                "dialogue": "總之，謝謝高雄捷運、合作的景點，還有今天來參加的各位～",
                                                "branch_obj": {},
                                                "effect_obj": {}
                                            },
                                            {
                                                "character": "雅朵",
                                                "facial_exp": "Art_happy.png",
                                                "dialogue": "謝謝你們！！！！",
                                                "branch_obj": {},
                                                "effect_obj": {
                                                    "type": "get_item",
                                                    "targetID": "0009",
                                                    "count": 1
                                                }
                                            }
                                        ],
                                        "effect_obj": {
                                            "type": "update_vibe",
                                            "target": {
                                                "Feiyong": 0
                                            }
                                        }
                                    },
                                    {
                                        "response": "高雄捷運處長的生日？",
                                        "following": [

                                            {
                                                "character": "我",
                                                "facial_exp": "",
                                                "dialogue": "是高捷的處長的生日吧！！！ 糟了，我竟然忘了...",
                                                "branch_obj": {},
                                                "effect_obj": {}
                                            },
                                            {
                                                "character": "飛揚",
                                                "facial_exp": "Feiyong_shock.png",
                                                "dialogue": "我們總之想個方法吧...",
                                                "branch_obj": {},
                                                "effect_obj": {}
                                            },
                                            {
                                                "character": "我",
                                                "facial_exp": "",
                                                "dialogue": "要送什麼呢.....?",
                                                "branch_obj": {},
                                                "effect_obj": {}
                                            },
                                            {
                                                "character": "雅朵",
                                                "facial_exp": "Art_shock.png",
                                                "dialogue": "啊！ 我想到了。我記得處長之前是工程部門的，所以也許他會喜歡這個吧！",
                                                "branch_obj": {},
                                                "effect_obj": {
                                                    "type": "get_item",
                                                    "targetID": "0004",
                                                    "count": 1
                                                }
                                            },
                                            {
                                                "character": "飛揚",
                                                "facial_exp": "Feiyong_shock.png",
                                                "dialogue": "雅朵、你怎麼會隨身攜帶扳手在身上呀！！？",
                                                "branch_obj": {},
                                                "effect_obj": {}
                                            },
                                            {
                                                "character": "雅朵",
                                                "facial_exp": "Art_happy.png",
                                                "dialogue": "先不要管這個了，我們快把禮物送給處長吧～～～",
                                                "branch_obj": {},
                                                "effect_obj": {}
                                            }

                                        ],
                                        "effect_obj": {
                                            "type": "update_vibe",
                                            "target": {
                                                "Feiyong": 0
                                            }
                                        }
                                    }
                                ]
                            },
                            {
                                "character": "",
                                "facial_exp": "",
                                "dialogue": "",
                                "branch_obj": {},
                                "effect_obj": {"type": "theme_transition"}
                            },
                            {
                                "type": "dialogue",
                                "character": "我",
                                "facial_exp": "",
                                "dialogue": "謝謝大家，希望你們會喜歡這個遊戲！",
                                "branch_obj": {},
                                "effect_obj": {}
                            },
                            {
                                "type": "dialogue",
                                "character": "雅朵",
                                "facial_exp": "Art_happy.png",
                                "dialogue": "也希望大家會喜歡高雄這個美麗的城市～",
                                "branch_obj": {},
                                "effect_obj": {}
                            },
                            {
                                "type": "dialogue",
                                "character": "飛揚",
                                "facial_exp": "Feiyong_happy.png",
                                "dialogue": "還有即將和我們合作的台北以及日本福岡唷～～",
                                "branch_obj": {},
                                "effect_obj": {
                                    "type": "get_item",
                                    "targetID": "0001",
                                    "count": 1
                                }
                            },
                            {
                                "type": "dialogue",
                                "character": "雅朵",
                                "facial_exp": "Art_happy.png",
                                "dialogue": "特別任務完成記念：遊戲發表會",
                                "branch_obj": {},
                                "effect_obj": {
                                    "type": "mission_complete",
                                    "complete": "KSM0024",
                                    "vibe": "Low"
                                }
                            }
                        ]
                    }
                });
                var deferred = $q.defer();
                setTimeout(function () {
                    return deferred.resolve({ data: mock });
                }, 1000);
                return deferred.promise;
            },

            getLocations: function () {
                var mock = angular.fromJson({
                    "Location": [
                        {
                            "id": "KSL6",
                            "name": "西子灣",
                            "description": "柴山山麓下，由平灘和淺沙所構成的海水浴場，以夕陽及天然礁石聞名的海灣。\n傍晚時分的夕照，是為台灣名景之一。",
                            "transportation": "搭乘捷運橘線至西子灣站(O1)1號出口，自行租車代步或步行前往。",
                            "image": "https://metroromances3.s3.amazonaws.com/e42568347602f52d1aa39307eeac6d34_KRT2_stops-6-a.png",
                            "darkImage": "https://metroromances3.s3.amazonaws.com/952d6430024780290721aa0aa45ae37b_KRT2_stops-6.png",
                            "cssTop": "50",
                            "cssLeft": "12",
                            "lat": 22.6249034,
                            "lon": 120.2626498,
                            "backgroundImage": "https://metroromances3.s3.amazonaws.com/e1fce9018c292711bb2b07772891970c_05_Sizihwan.png"
                        },
                        {
                            "id": "KSL0",
                            "name": "起始任務",
                            "description": "起始任務",
                            "transportation": "起始任務",
                            "image": "https://metroromances3.s3.amazonaws.com/dc726bfa181d3b990a2144a3b6d06bca_1px.png",
                            "darkImage": "https://metroromances3.s3.amazonaws.com/281bb72d9945cbcba02582c388e32b71_1px.png",
                            "cssTop": "0",
                            "cssLeft": "0",
                            "lat": 0,
                            "lon": 0,
                            "backgroundImage": "https://metroromances3.s3.amazonaws.com/c4df95c0efe7bc77d7b7c6525a70f364_01_Beginning_S.png"
                        },
                        {
                            "id": "KSL13",
                            "name": "旗津",
                            "description": "旗津島原本是和南端小港區相連的半島，1673年建旗後媽祖宮。\n日治時期明治卅一年(1898)，日本在此設立高雄第一所學校打狗公學校 (今旗津國小)。",
                            "transportation": "搭乘捷運橘線至西子灣站(O1)1號出口，自行租車代步或搭乘渡輪前往旗津。",
                            "image": "https://metroromances3.s3.amazonaws.com/1f324681179eaab8e7a11cce93e03fa9_KRT2_stops-13-a.png",
                            "darkImage": "https://metroromances3.s3.amazonaws.com/83488c8bf5a659f8dac77c5bf513d09d_KRT2_stops-13.png",
                            "cssTop": "60",
                            "cssLeft": "21",
                            "lat": 22.6141979,
                            "lon": 120.2671167,
                            "backgroundImage": "https://metroromances3.s3.amazonaws.com/1a6be42ee7d910e85f839d21ea32786f_12_Cijin.png"
                        },
                        {
                            "id": "KSL1",
                            "name": "85大樓",
                            "description": "緊鄰著高雄港和新光碼頭，為台灣第二高的摩天大樓，也是90年代後期臺灣最高的建築物。",
                            "transportation": "搭乘捷運紅線至三多商圈站(R8)，出2號出口往新光路方向步行即可到達高雄85大樓。",
                            "image": "https://metroromances3.s3.amazonaws.com/090129d1b029a50c910efa2a89de8c38_KRT2_stops-1-a.png",
                            "darkImage": "https://metroromances3.s3.amazonaws.com/7b8c56f707693c2f66e444f1b49cfe32_KRT2_stops-1.png",
                            "cssTop": "45",
                            "cssLeft": "57",
                            "lat": 22.611663,
                            "lon": 120.30013,
                            "backgroundImage": "https://metroromances3.s3.amazonaws.com/3179600fcfbfc76f7ab6c29859bc43d1_02_85%20Sky%20Tower.png"
                        },
                        {
                            "id": "KSL2",
                            "name": "大魯閣草衙道",
                            "description": "鄰近小港機場、亞洲新灣區，以體驗為訴求的休閒購物天堂。",
                            "transportation": "搭乘捷運紅線至草衙站(R4A)2號出口即可到達。",
                            "image": "https://metroromances3.s3.amazonaws.com/f8e94b7f768dd3de14dab4e71dbba80f_KRT2_stops-2-a.png",
                            "darkImage": "https://metroromances3.s3.amazonaws.com/0b02459e671c872dcc0c7c86d22243b9_KRT2_stops-2.png",
                            "cssTop": "63",
                            "cssLeft": "46",
                            "lat": 22.5823068,
                            "lon": 120.3273107,
                            "backgroundImage": "https://metroromances3.s3.amazonaws.com/2b27b3e601e36c078f43365a6053a133_03_TarokoPark_S.png"
                        },
                        {
                            "id": "KSL3",
                            "name": "駁二藝術特區",
                            "description": "位於高雄鹽埕區的藝術園區，以前衛、實驗、創新為理念來打造的國際藝術平台。",
                            "transportation": "搭乘捷運橘線至鹽埕埔站(O2)1號出口，沿大勇路向南步行約5分鐘即可到達。",
                            "image": "https://metroromances3.s3.amazonaws.com/db12ed6ad699ec8dd4b200d342735089_KRT2_stops-3-a.png",
                            "darkImage": "https://metroromances3.s3.amazonaws.com/c073cb854936b770724cebaef013ff33_KRT2_stops-3.png",
                            "cssTop": "53",
                            "cssLeft": "27",
                            "lat": 22.6197565,
                            "lon": 120.2808448,
                            "backgroundImage": "https://metroromances3.s3.amazonaws.com/de9e5f125933c0e80e1219e00e824d0e_04_Pier-2%20Art%20Center.png"
                        },
                        {
                            "id": "KSL5",
                            "name": "高雄巨蛋",
                            "description": "為一座可容納一萬五千人的多功能體育館，並於 2009年舉辦世界運動會。",
                            "transportation": "搭乘捷運紅線至巨蛋站(R14)5號出口即可到達。",
                            "image": "https://metroromances3.s3.amazonaws.com/debc2ac8bd1f69c4065bef6f083c7360_KRT2_stops-5-a.png",
                            "darkImage": "https://metroromances3.s3.amazonaws.com/6aeaacdd332063a059e83b3f1c723d44_KRT2_stops-5.png",
                            "cssTop": "30",
                            "cssLeft": "41",
                            "lat": 22.668822,
                            "lon": 120.3008562,
                            "backgroundImage": "https://metroromances3.s3.amazonaws.com/a59f6f4fc9d3804d240a18bab9632e7d_07_Kaohsiung%20Arena.png"
                        },
                        {
                            "id": "KSL7",
                            "name": "瑞豐夜市",
                            "description": "起始於瑞豐街，因而得名瑞豐夜市。約有20年之久歷史，由當初的小攤販，演變為今日大規模知名夜市。",
                            "transportation": "搭乘捷運紅線至巨蛋站(R14)1號出口，步行5分鐘即可到達。",
                            "image": "https://metroromances3.s3.amazonaws.com/b6439529cd0a69f627656a9ed8cf25d9_KRT2_stops-7-a.png",
                            "darkImage": "https://metroromances3.s3.amazonaws.com/dcc386c321cae98ccecbc325c03056b1_KRT2_stops-7.png",
                            "cssTop": "27",
                            "cssLeft": "26",
                            "lat": 22.6662386,
                            "lon": 120.2984052,
                            "backgroundImage": "https://metroromances3.s3.amazonaws.com/d7bdb893be65abea2df994d854407061_08_Ruifeng%20Night%20Market.png"
                        },
                        {
                            "id": "KSL10",
                            "name": "LOVE 觀景台",
                            "description": "位於壽山公園旁，原為「高雄神社」。\n於 2013年興建「LOVE」裝置藝術，現已成為高雄代表觀光景點之一。",
                            "transportation": "搭乘捷運橘線至鹽埕埔站(O2)4號出口，轉乘56路公車。",
                            "image": "https://metroromances3.s3.amazonaws.com/c2f8873b89951027e3fce3bcf13e42af_KRT2_stops-10-a.png",
                            "darkImage": "https://metroromances3.s3.amazonaws.com/8c7f2f92474c630a5118ee3db77296be_KRT2_stops-10.png",
                            "cssTop": "44",
                            "cssLeft": "18",
                            "lat": 22.6251589,
                            "lon": 120.2733144,
                            "backgroundImage": "https://metroromances3.s3.amazonaws.com/ce4676934c91e9d854e0f9937d9c2bcf_11_LOVE%20Observation%20Deck.png"
                        },
                        {
                            "id": "KSL11",
                            "name": "愛河",
                            "description": "古名打狗川、高雄川、ㄧ號運河，是條運河和小型河川。\n現已成為高雄市重要旅遊景點，尤其是河畔的夜景。",
                            "transportation": "搭乘捷運橘線至鹽埕埔站(O2)2號出口步行即可抵達。",
                            "image": "https://metroromances3.s3.amazonaws.com/f0b06e904571cd685e3d8f20761d195b_KRT2_stops-11-a.png",
                            "darkImage": "https://metroromances3.s3.amazonaws.com/37832f4cba0f066fecb8ca3870d863d0_KRT2_stops-11.png",
                            "cssTop": "49",
                            "cssLeft": "33",
                            "lat": 22.6257559,
                            "lon": 120.2882989,
                            "backgroundImage": "https://metroromances3.s3.amazonaws.com/537191f9f7326459c8ad809aed51bd4f_13_Love%20River.png"
                        },
                        {
                            "id": "KSL12",
                            "name": "旗後砲台",
                            "description": "砲臺建築是清末海防的一大特色，旗後砲臺為聘英國工程師設計，\n門柱上砌「囍」字圖案，建築為中西合璧式砲臺。",
                            "transportation": "搭乘捷運橘線至西子灣站(O1)1號出口，自行租車代步或搭乘渡輪前往旗津。",
                            "image": "https://metroromances3.s3.amazonaws.com/245bff1e045e753a44d5e5970b4b50e2_KRT2_stops-12-a.png",
                            "darkImage": "https://metroromances3.s3.amazonaws.com/227b26feb4aa359d8dd626b01338291a_KRT2_stops-12.png",
                            "cssTop": "57",
                            "cssLeft": "9",
                            "lat": 22.6122111,
                            "lon": 120.2628944,
                            "backgroundImage": "https://metroromances3.s3.amazonaws.com/9882768b20af0e55a09171c729592427_14_Cihou%20Fort.png"
                        },
                        {
                            "id": "KSL4",
                            "name": "大東文化藝術中心",
                            "description": "為大東國小轉型的精緻型迷你藝術小學。其中藝術中心圖書館是台灣首座藝術圖書館。",
                            "transportation": "搭乘捷運橘線至大東文化藝術中心站(O13)2號出口即可到達。",
                            "image": "https://metroromances3.s3.amazonaws.com/906db601d3bef9c42ed4f0d45aa68903_KRT2_stops-4-a.png",
                            "darkImage": "https://metroromances3.s3.amazonaws.com/179b5405eb6b0b265457346101a07a0d_KRT2_stops-4.png",
                            "cssTop": "55",
                            "cssLeft": "70",
                            "lat": 22.6248468,
                            "lon": 120.3627813,
                            "backgroundImage": "https://metroromances3.s3.amazonaws.com/ed74e093a95adfab680aaaec2aaaf486_06_Dadong%20Arts%20Center.png"
                        },
                        {
                            "id": "KSL9",
                            "name": "高雄市立美術館",
                            "description": "為臺灣第三座公立美術館。以展覽廳，加上兒童美術館與雕塑公園，共同構成內惟埤文化園區。",
                            "transportation": "搭乘捷運紅線至凹仔底站(R13)轉乘紅32、紅33或紅35路公車前往。",
                            "image": "https://metroromances3.s3.amazonaws.com/dd59e406f689d00dfa6b37507ceb70b7_KRT2_stops-9-a.png",
                            "darkImage": "https://metroromances3.s3.amazonaws.com/63b3d3daa9f5259746982824e7c1a1cf_KRT2_stops-9.png",
                            "cssTop": "37",
                            "cssLeft": "27",
                            "lat": 22.6568604,
                            "lon": 120.285424,
                            "backgroundImage": "https://metroromances3.s3.amazonaws.com/4157207474bb241d633d433d03a00691_10_Kaohsiung%20Museum%20of%20Fine%20Arts.png"
                        },
                        {
                            "id": "KSL8",
                            "name": "科學工藝博物館",
                            "description": "台灣第一座應用科學博物館。以蒐藏及研究科技文物、展示與科技為主。",
                            "transportation": "搭乘捷運紅線至高雄車站（R11）前站轉搭60號公車或搭乘捷運紅線至後驛站(R12)轉乘紅28接駁公車抵達。",
                            "image": "https://metroromances3.s3.amazonaws.com/b228d9ca4ef10e6bda84a2ee888ed25b_KRT2_stops-8-a.png",
                            "darkImage": "https://metroromances3.s3.amazonaws.com/9dff74652d83c28c37b73d7bda9e2162_KRT2_stops-8.png",
                            "cssTop": "40",
                            "cssLeft": "52",
                            "lat": 22.6406819,
                            "lon": 120.3205478,
                            "backgroundImage": "https://metroromances3.s3.amazonaws.com/82777a8c1c68d1006eae898cb199e8f9_09_National%20Science%20and%20Technology%20Museum.png"
                        },
                        {
                            "id": "KSL14",
                            "name": "壽山動物園",
                            "description": "南台灣最大的公立動物園，為南部重要之動物保育及教育據點，更是闔家出遊的歡樂園地。",
                            "transportation": "搭乘捷運橘線至鹽埕埔站(O2)4號出口，轉乘56路公車。",
                            "image": "https://metroromances3.s3.amazonaws.com/a3df98fb7cbd27ed82cabd47194e53cf_KRT2_stops-14-a.png",
                            "darkImage": "https://metroromances3.s3.amazonaws.com/90e74792b3d643d5955e9f97ce85ade2_KRT2_stops-14.png",
                            "cssTop": "37",
                            "cssLeft": "12",
                            "lat": 22.6345063,
                            "lon": 120.2729655,
                            "backgroundImage": "https://metroromances3.s3.amazonaws.com/5163d2c166600dce025254756d972b87_15_Shou%20Shan%20Zoo.png"
                        },
                        {
                            "id": "KSL15",
                            "name": "光之穹頂",
                            "description": "由義大利藝術家水仙大師 (Narcissus Quagliata)打造。\n美國旅遊網站曾評選全世界最美麗的15座地鐵站之一。",
                            "transportation": "搭乘捷運紅線美麗島站至B1穿堂層。",
                            "image": "https://metroromances3.s3.amazonaws.com/bde5c176a9758273c065fd902dbc06e9_KRT2_stops-15-a.png",
                            "darkImage": "https://metroromances3.s3.amazonaws.com/7f901859bda0cd68ac1362d29d1ed5dc_KRT2_stops-15.png",
                            "cssTop": "47",
                            "cssLeft": "44",
                            "lat": 22.63137,
                            "lon": 120.2997652,
                            "backgroundImage": "https://metroromances3.s3.amazonaws.com/d8a6c1a40745a04a461dbcf11120e179_16_Dome%20of%20Light.png"
                        }
                    ]
                });
                var deferred = $q.defer();
                setTimeout(function () {
                    return deferred.resolve({ data: mock });
                }, 1000);
                return deferred.promise;
            },

            updateUserData: function (userData) {
                var mock = { result: "OK" };
                var deferred = $q.defer();
                setTimeout(function () {
                    return deferred.resolve({ data: mock });
                }, 1000);
                return deferred.promise;
            },

            updateUserFB: function (fbid) {
                console.log("updateUserFB");
                var uuid = $cordovaDevice.getUUID();
                var params = {
                    deviceId: uuid,
                    facebookId: fbid,
                    code: CODE
                }
                return $http.post('https://serene-cliffs-10627.herokuapp.com/update_user_fb', params);
            },


            checkPreRegister: function () {
                console.log("check pre");
                var fbid = localStorage.getItem('facebookId');
                console.log(fbid);
                var params = {
                    fbid: fbid,
                    code: CODE
                }
                return $http.post('https://serene-cliffs-10627.herokuapp.com/check_pre_register', params);
            }
        }
    });
