// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
var app = angular.module('metro-romance', ['ionic', 'ngCordova', 'ngAnimate'])

    .run(function ($ionicPlatform, $ionicPopup, $rootScope, $cordovaMedia, $state, $window, $timeout, $q, $ionicLoading, ApiService) {
        $ionicPlatform.ready(function () {

            app.$q = $q;
            app.$state = $state;
            app.$rootScope = $rootScope;
            app.$ionicLoading = $ionicLoading;
            app.apiService = ApiService;
            app.isAndroid = ionic.Platform.isAndroid();
            app.$cordovaMedia = $cordovaMedia;

            if (!app.isAndroid) {
                cordova.plugins.statusbarOverlay.hide();
            }

            // Check for network connection
            $timeout(function () {
                $ionicLoading.show({
                    template: 'Loading...',
                });
                app.iniRootScopeData()
                    .then(function (res) {

                        var _event = {
                            eventID: "E0004",
                            info: "default-free-ticket",
                            itemID: "0014",
                            itemCount: 20
                        };
                        app.eventGetItem(_event)
                            .finally(function () {
                                $ionicLoading.hide();
                            });

                    }, function () {
                        $ionicLoading.hide();
                    });
            }, 1000);

            $window.addEventListener('offline', function () {
                $ionicPopup.confirm({
                    title: '沒有網絡',
                    content: '對不起，沒有檢測到網路連接。請重新連接，然後重試。',
                    cancelText: '離開遊戲',
                    okText: '我知道了'
                })
                    .then(function (result) {
                        if (!result) {
                            ionic.Platform.exitApp();
                        } else {
                            $ionicLoading.hide();
                        }
                    });
                $rootScope.$digest();
            });
            /*
                        $window.addEventListener('online', function () {
                            if (!$rootScope.userData) {
                                $ionicLoading.show({
                                    template: 'Loading...',
                                });
            
                                $timeout(function () {
                                    app.iniRootScopeData()
                                        .then(function (res) {
                                            $ionicLoading.hide();
                                        }, function () {
                                            $ionicLoading.hide();
                                        });
                                }, 1000);
                            }
                            //alert('online');
                            $rootScope.$digest();
                        });
            */

            if (window.cordova) {
                // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
                // for form inputs)
                //cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);

                // Don't remove this line unless you know what you are doing. It stops the viewport
                // from snapping when text inputs are focused. Ionic handles this internally for
                // a much nicer keyboard experience.
                //cordova.plugins.Keyboard.disableScroll(true);


                //[1] Wikitude

                app.wikitudePlugin = cordova.require("com.wikitude.phonegap.WikitudePlugin.WikitudePlugin");

            }

            //[0] disabled hardware back
            $ionicPlatform.registerBackButtonAction(function (event) {
                event.preventDefault();
            }, 100);



            //[2] Prepare data

            //START [5] Media 

            if (app.isAndroid) {
                app.media.music = $cordovaMedia.newMedia(app.getMediaURL(app.music_path));
                app.media.music.play();
            } else {
                _bg_music = document.createElement("audio");
                _bg_music.src = app.getMediaURL(app.music_path);
                app.media.sound_bg = _bg_music;
                app.media.sound_bg.loop = true;
                app.media.sound_bg.play();
            }

            $ionicPlatform.on("pause", function () {
                app.media.music.pause();
            });
            $ionicPlatform.on("resume", function () {
                app.media.music.play();
            });

            var _heart, _conversation, _others;

            if (app.isAndroid) {

                _heart = new Media(app.getMediaURL("media/03_button_heart.mp3"), //cordova.file.applicationDirectory + 
                    // success callback
                    function () {
                        //console.log("playAudio():Audio Success"); 
                    },
                    // error callback
                    function (err) {
                        console.log("playAudio():Audio Error: ");
                        console.log(err);
                    }
                );
                _conversation = new Media(app.getMediaURL("media/02_conversation.mp3"), //cordova.file.applicationDirectory + 
                    // success callback
                    function () {
                        //console.log("playAudio():Audio Success");
                    },
                    // error callback
                    function (err) {
                        console.log("playAudio():Audio Error: ");
                        console.log(err);
                    }
                );
                _others = new Media(app.getMediaURL("media/01_others.mp3"), //cordova.file.applicationDirectory + 
                    // success callback
                    function () {
                        //console.log("playAudio():Audio Success"); 
                    },
                    // error callback
                    function (err) {
                        console.log("playAudio():Audio Error: ");
                        console.log(err);
                    }
                );
            } else {
                _heart = document.createElement("audio");
                _heart.src = app.getMediaURL("media/03_button_heart.mp3");

                _conversation = document.createElement("audio");
                _conversation.src = app.getMediaURL("media/02_conversation.mp3");

                _others = document.createElement("audio");
                _others.src = app.getMediaURL("media/01_others.mp3");
            }

            app.media.sound_heart = _heart;
            app.media.sound_conversation = _conversation;
            app.media.sound_others = _others;

            //END [5] Media

            //START [6] Capture

            app.capture = function () {
                app.wikitudePlugin.captureScreen(
                    function (absoluteFilePath) {
                        alert("snapshot stored at:\n" + absoluteFilePath);
                    },
                    function (errorMessage) {
                        alert(errorMessage);
                    },
                    false, null
                );
            }

            //END [6] Capture


        });
    });

app.iniRootScopeData = function () {
    if (!app.$rootScope.userData) {
        var deferred = app.$q.defer();
        app.$q.all([app.apiService.getAllItems(), app.apiService.getUserData(), app.apiService.getRandomMission(), app.apiService.getLocations(), app.apiService.getNewNotifications()])
            .then(function (res) {
                console.log(res);
                app.$rootScope.allItems = res[0].data.Item;
                app.$rootScope.userData = res[1].data.User;
                app.$rootScope.randomMission = res[2].data;
                app.$rootScope.locations = res[3].data;
                app.$rootScope.newMissionTipsList = res[4].data;

                console.log('item', app.$rootScope.allItems);
                console.log('user-data', app.$rootScope.userData);
                console.log('random-mission', app.$rootScope.randomMission);
                console.log('locations', app.$rootScope.locations);
                console.log('new-mission-tips', app.$rootScope.newMissionTipsList);
                deferred.resolve(app.$rootScope.userData);

            }, function (err) {
                console.log(err);
                deferred.reject(err);
            });
        return deferred.promise;
    } else {
        return false;
    }
}
app.media = {};

app.getMediaURL = function (_path) {
    if (app.isAndroid) {
        return (cordova.file.applicationDirectory + "www/" + _path);
    }
    return _path;
}
app.music_path = "media/main_music.mp3";
app.changeBackgroundMusic = function (chapterName) {
    var new_path;
    switch (chapterName) {
        case "TP":
            new_path = "media/tp_music.mp3";
            break;
        case "FK":
            new_path = "media/fk_music.mp3";
            break;
        case "KS":
            new_path = "media/main_music.mp3";
            break;
    }

    if (app.music_path === new_path) {
        return false;
    } else {
        app.music_path = new_path;
    }

    if (app.isAndroid) {
        app.media.music.stop();
        app.media.music = app.$cordovaMedia.newMedia(app.getMediaURL(app.music_path));
        app.media.music.play();
    } else {
        _bg_music = document.createElement("audio");
        _bg_music.src = app.getMediaURL(app.music_path);
        app.media.sound_bg.pause();
        app.media.sound_bg = _bg_music;
        app.media.sound_bg.loop = true;
        app.media.sound_bg.play();
    }
}

app.loadARchitectFK = function () {
    // check if the current device is able to launch ARchitect Worlds
    ar = {
        "path": "www/ar-ks.html",
        "requiredFeatures": [
            "2d_tracking"
        ],
        "startupConfiguration": {
            "camera_position": "back"
        }
    };
    app.wikitudePlugin.isDeviceSupported(function () {

        app.wikitudePlugin.setOnUrlInvokeCallback(function (url) {

            var targetStation = url.substring(22);
            if ((targetStation.indexOf("KSL") >= 0) || (targetStation.indexOf("TPL") >= 0) || (targetStation.indexOf("FKL") >= 0)) {

                var ar_url = ['FKL4', 'FKL5', 'FKL6']; //如果是在 福岡三個相機的地方
                if (ar_url.indexOf(targetStation) >= 0) {

                    app.$ionicLoading.show({
                        template: 'Loading...',
                    });
                    localStorage.setItem('ks-locationID', targetStation);
                    app.apiService.getMission(targetStation, app.$rootScope.userData)
                        .then(function (res) {
                            if (!!res.data.error) {
                                app.$ionicLoading.hide();
                                if (res.data.error == "no mission found") {
                                    alert('新的任務還沒出現，去查看簡訊前往下個景點吧!!');
                                    app.$state.go('ks-main');
                                    return false;
                                } else {
                                    console.log('error', res.data);
                                    app.$state.go('ks-main');
                                    return false
                                }
                            }
                            app.$ionicLoading.hide();
                            app.$rootScope.output = res.data;
                            app.$state.go('ks-des', { 'type': 'newUser' });
                        });
                    app.wikitudePlugin.close();

                } else {
                    app.$state.go('ks-des', { 'id': targetStation });
                    app.wikitudePlugin.close();
                }
            } else if (targetStation === '85SkyTower'  || targetStation === 'YueYue') {

                app.$ionicLoading.show({
                    template: 'Loading...',
                });
                var _event;
                if (targetStation === '85SkyTower') {
                    _event = {
                        eventID: "E0002",
                        info: "85SkyTowerArScan",
                        itemID: "0014",
                        itemCount: 20
                    };
                }
 
                if (targetStation === 'YueYue') {
                    _event = {
                        eventID: "E0003",
                        info: "YueYueArScan",
                        itemID: "0014",
                        itemCount: 5
                    };
                }
          
                app.eventGetItem(_event)
                    .finally(function () {
                        app.$ionicLoading.hide();
                        app.wikitudePlugin.close();
                        app.media.sound_others.play();
                    });

            } else if (targetStation === 'leave') {
                app.wikitudePlugin.close();
                app.media.sound_others.play();

            } else if (targetStation === 'captureScreen') {
                app.capture();
                console.log('captureScreen');
            } else {
                //alert('ARchitect => PhoneGap ' + url);
                alert(targetStation);
            }
        });
        // inject poi data using phonegap's GeoLocation API and inject data using World.loadPoisFromJsonData


        app.wikitudePlugin.loadARchitectWorld(function successFn(loadedURL) {
            /* Respond to successful world loading if you need to */
        }, function errorFn(error) {
            alert('Loading AR web view failed: ' + error);
        }, ar.path, ar.requiredFeatures, ar.startupConfiguration);

    }.bind(this), function (errorMessage) {
        alert(errorMessage);
    },
        ar.requiredFeatures
    );
}

app.eventGetItem = function (_event) {
    var deferred = app.$q.defer();

    var thisEvent = app.$rootScope.userData.event.filter(function (e) {
        return (!!e.eventID) && (e.eventID == _event.eventID)
    });

    if (thisEvent.length > 0) {
        setTimeout(function () {
            deferred.reject();
        }, 100);
    } else {

        //[1]得到車票
        var _checkItem = app.$rootScope.userData.item.filter(function (item) {
            return item.ID === _event.itemID;
        });
        if (_checkItem.length > 0) {
            //物品資訊存在,更新
            app.$rootScope.userData.item.forEach(function (item) {
                if (item.ID === _event.itemID) {
                    item.Count = item.Count + _event.itemCount;
                }
            });
        } else {
            //物品資訊不存在，新增
            var _newItem = {
                ID: _event.itemID,
                Count: _event.itemCount
            };
            app.$rootScope.userData.item.push(_newItem);
        }

        //[2]紀錄得到此物品
        var _newEvent = {
            eventID: _event.eventID,
            info: _event.info
        };
        app.$rootScope.userData.event.push(_newEvent);

        //[3] 立刻更新資訊

        app.apiService.updateUserData(app.$rootScope.userData)
            .then(function (res) {

                var _item = app.$rootScope.allItems.filter(function (item) {
                    return item.ID === _event.itemID
                })[0];
                app.$rootScope.arItemPopup = {
                    show: true,
                    id: _item.ID,
                    name: _item.name,
                    count: _event.itemCount
                }
                deferred.resolve();
                // app.wikitudePlugin.close();
                // app.media.sound_others.play();
            });
    }
    return deferred.promise;
}

/*
app.loadARchitectKS = function () {
    // check if the current device is able to launch ARchitect Worlds
    ar = {
        "path": "www/ar-ks.html",
        "requiredFeatures": [
            "2d_tracking"
        ],
        "startupConfiguration": {
            "camera_position": "back"
        }
    };
    app.wikitudePlugin.isDeviceSupported(function () {

        app.wikitudePlugin.setOnUrlInvokeCallback(function (url) {

            var targetStation = url.substring(22);
            if ((targetStation.indexOf("KSL") >= 0) || (targetStation.indexOf("TPL") >= 0) || (targetStation.indexOf("FKL") >= 0)) {
                app.$state.go('ks-des', { 'id': targetStation });
                app.wikitudePlugin.close();
            } else if (targetStation === 'leave') {
                app.wikitudePlugin.close();
                app.media.sound_others.play();
            } else if (targetStation === 'captureScreen') {
                app.capture();
                console.log('captureScreen');
            } else {
                //alert('ARchitect => PhoneGap ' + url);
                alert(targetStation);
            }
        }.bind(this));
        // inject poi data using phonegap's GeoLocation API and inject data using World.loadPoisFromJsonData
        
        //if ( example.requiredExtension === "ObtainPoiDataFromApplicationModel" ) {
        //    navigator.geolocation.getCurrentPosition(onLocationUpdated, onLocationError);
        //}
        
        app.wikitudePlugin.loadARchitectWorld(function successFn(loadedURL) {
            // Respond to successful world loading if you need to 
            console.log(loadedURL);
        }, function errorFn(error) {
            alert('Loading AR web view failed: ' + error);
        }, ar.path, ar.requiredFeatures, ar.startupConfiguration);

    }.bind(this), function (errorMessage) {
        alert(errorMessage);
    },
        ar.requiredFeatures
    );
}
*/
    // --- End Wikitude Plugin --