// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
(function () {


    function DemoDesController($scope, $rootScope, $ionicPlatform, $state, $ionicModal, $ionicLoading, $cordovaDevice, $timeout, apiService) {

        var vm = this;
        this.$state = $state;
        this.$cordovaDevice = $cordovaDevice;
        this.$scope = $scope;
        this.$rootScope = $rootScope;
        this.$ionicLoading = $ionicLoading
        this.$timeout = $timeout;
        this.apiService = apiService;

        vm.output = $rootScope.output;
        vm.vibe = this.getVibe($rootScope.userData.vibe, $rootScope.output.mission.character);
        vm.mission = $rootScope.output.mission; //app.service2[$state.params.id]; //get from pushstate;
        vm.locationID = localStorage.getItem('ks-locationID');
        vm.ThemeTransition = true;
        vm.missionComplete = false;
        vm.chapter = $rootScope.chapterName;
        console.log('stateParam', $state.params);
        console.log('appService', app.service2);

        //處理隨機任務
        vm.allItems = this.indexBy($rootScope.allItems, "ID");
        vm.userItems = $rootScope.userData.item
            .map(function (i) {
                return Object.assign({}, vm.allItems[i.ID], i);
            })
            .filter(function (i) {
                return (i.Count > 0) && (i.effect_obj.type === "vibe");
            });

        vm.randomMission = {};
        console.log(vm.userItems);

        //Item Modal Popup
        $ionicModal.fromTemplateUrl('view_components/popover/des-item.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function (modal) {
            $scope.itemModal = modal;
        });
        $scope.openItemModal = function (lo, special) {
            $scope.itemModal.show();
        };
        $scope.closeItemModal = function () {
            $scope.itemModal.hide();
        };
        // Cleanup the modal when we're done with it!
        $scope.$on('$destroy', function () {
            $scope.itemModal.remove();
        });
        // Execute action on hide modal
        $scope.$on('modal.hidden', function () {
            // Execute action
        });
        // Execute action on remove modal
        $scope.$on('modal.removed', function () {
            // Execute action
        });

        //進入對話模式  
        if (this.validateRandomMission()) {
            this.goMainMission();
        } else {
            this.goRandomMission();
        }

        //---------------------------------------
    }
    DemoDesController.prototype.validateRandomMission = function () {
        var vm = this;
        if (vm.mission.missionID === "KSM0001" || vm.mission.missionID === "KSM0024") {
            return true;
        }

        if (vm.vibe === "Low") {
            return true;
        }

        return (Math.random() > 0.5);
    }
    DemoDesController.prototype.goRandomMission = function () {
        var vm = this;

        var n = Math.floor(Math.random() * vm.mission.character.length); //隨機選一個角色
        vm.randomMission = vm.$rootScope.randomMission.filter(function (m) {
            return m.character === vm.mission.character[n];
        })[0];

        console.log('this random mission', vm.randomMission);
        vm.question = vm.randomMission.question[0];
        console.log(vm.question);
        vm.lineTotal = 999;
        vm.lineCount = 0;
        vm.showItemInfo = false;

        vm.randomMissionDialogue = {};
        setTimeout(function () {
            vm.$scope.openItemModal();
        }, 500);

    }

    DemoDesController.prototype.goMainMission = function () {
        var vm = this;
        //處理分支對話
        var _finalDialugue = [];

        var _mainDialogue = this.filtedDialogue(vm.output.dialog[this.vibe], vm.$rootScope.userData);

        if (!!vm.randomMissionDialogue) {
            console.log(vm.randomMissionDialogue);
            vm.randomMissionDialogue.push(
                {
                    type: "dialogue",
                    character: "",
                    facial_exp: "",
                    dialogue: "",
                    branch_obj: {},
                    effect_obj: { type: "theme_transition" }
                }
            )
            _finalDialugue = vm.randomMissionDialogue.concat(_mainDialogue);
        } else {
            _finalDialugue = _mainDialogue;
        }

        //處理角色忘了表情 
        _finalDialugue.forEach(function (_d) {
            if ((!!_d.facial_exp) && (_d.facial_exp.indexOf('_.png') >= 0)) {
                _d.facial_exp = _d.facial_exp.replace('_.png', '_normal.png');
            }
        });

        vm.finalDialogue = _finalDialugue;

        vm.line = _finalDialugue[0];
        vm.lineCount = 0;
        vm.followingCount = 0;
        vm.lineTotal = _finalDialugue.length - 1;
        vm.getItemPopup = false;
        vm.showReward = false;
        vm.reward = "";
        vm.isFollowing = false;
        vm.followingLines = [];
    }

    DemoDesController.prototype.indexBy = function (list, iteratee) {
        var result = {};
        list.forEach(function (item) {
            result[item[iteratee]] = item;
        });
        return result;
    }

    DemoDesController.prototype.filtedDialogue = function (rawDialogue, userData) {


        var _vibeValidate = function (_condition, _userData) {
            var _result = _condition.map(function (c) {
                switch (c.type) {
                    case "vibe_value":
                        var _userVibe = _userData.vibe[c.target]; //Feiyong

                        switch (c.operator) {
                            case "greater":
                                return _userVibe >= c.value;  //75
                                break;
                            case "less":
                                return _userVibe < c.value;  //75
                                break;
                            default:
                                return false;
                        }
                        break;

                    case "vibe_character":
                        var _userVibe = _userData.vibe[c.target],
                            _compareVibe = _userData.vibe[c.value]; //Art
                        return _userVibe > _compareVibe;

                        break;

                    case "vibe_all_character":
                        var _userVibe = _userData.vibe[c.target],
                            _compareActs = c.value.split(',');
                        var isMost = true;
                        _compareActs.forEach(function (_act) {
                            isMost = isMost && (_userVibe >= _userData.vibe[_act]);  //大於等於每一個人(含自己)
                        });
                        if (c.operator === "greater") {
                            return isMost;
                        } else {
                            return !isMost;
                        }
                        break;

                    default:
                        return false;
                };
            });

            var _final = _result.reduce(function (pre, now) {
                return pre && now;
            }, true); //有任何一個 condition是false就 回傳 false

            return _final;
        }

        var _filtedDialogue = rawDialogue.filter(function (dialogue) {
            console.log(dialogue);

            if (dialogue.type !== "dialogue") {
                if (dialogue.type === "select") {
                    dialogue.select.forEach(function (_obj) {
                        _obj.following = _obj.following.filter(function (_f) {
                            if ((Object.keys(_f.branch_obj).length >= 0) && _f.branch_obj.type === "branch_vibe") {
                                var _condition = _f.branch_obj.condition;
                                return _vibeValidate(_condition, userData);
                            } else {
                                return true;
                            }
                        });
                    });
                }
                return true; // 有可能是select
            } else if (Object.keys(dialogue.branch_obj).length === 0) {
                return true; // 確認 branch_obj 不是空物件
            } else if (dialogue.branch_obj.type === "branch_vibe") {
                //根據玩家的好感度
                /*{
                type: "branch_vibe",
                condition: [{type: "vibe_value",     target: "Feiyong", operator: "greater",   value: 75},
                            {type: "vibe_character", target: "Feiyong", operator: "character", value: "Art"}
                            {type: "vibe_all_character", target: "Emilia",  operator: "less",  value: "Ann,Nana,Sora,Emilia"}]]
                }*/
                var _condition = dialogue.branch_obj.condition;
                return _vibeValidate(_condition, userData);

            } else if (dialogue.branch_obj.type === "branch_mission") {
                //根據玩家的任務進度 
                var _mission = dialogue.branch_obj.target,
                    _needComplete = dialogue.branch_obj.complete;

                var userMissionComplete = userData.mission.filter(function (m) {
                    return m.ID === _mission;
                });

                if (userMissionComplete.length === 0) {
                    //玩家尚未完成此任務
                    return _needComplete ? false : true;

                } else {

                    //玩家 完成此任務
                    if (_needComplete) {
                        //{type: "branch_mission",target: "KSM0016",complete: true,vibe: [ "Low","Mid","High"]
                        //判斷好感度
                        var _vibes = dialogue.branch_obj.vibe;
                        var _userMissionVibe = userMissionComplete[0].vibe;
                        if (_vibes.indexOf(_userMissionVibe) < 0) {
                            return false;//不符合條件
                        } else {
                            return true; //符合條件
                        }
                    } else {
                        return false
                    }
                }
            } else if (dialogue.branch_obj.type === "branch_item") {
                var _itemID = dialogue.branch_obj.target,
                    _needHold = dialogue.branch_obj.hold;

                var _userItemIDs = userData.item.map(function (i) {
                    return i.ID;
                });
                if (_userItemIDs.indexOf(_itemID) < 0) {
                    return _needHold ? false : true;
                } else {
                    return _needHold ? true : false;
                }
            }

            return true;
        });
        console.log(_filtedDialogue);
        return _filtedDialogue;

    }

    DemoDesController.prototype.getVibe = function (vibeTable, characters) {
        var _vibe = 0;
        characters.forEach(function (c) {
            _vibe = (vibeTable[c] > _vibe) ? vibeTable[c] : _vibe;
        })
        if (_vibe < 34) {
            return "Low";
        } else if (_vibe < 67) {
            return "Mid"
        }
        return "High";
    }

    DemoDesController.prototype.addMission = function (route) {
        var vm = this;
        vm.$ionicLoading.show({
            template: 'Loading...',
        });

        if (vm.$rootScope.userData.unlock.indexOf(vm.locationID) < 0) {
            vm.$rootScope.userData.unlock.push(vm.locationID);
        }

        vm.mission.unlock = true;
        vm.mission.line = "";

        // save API : TODO
        var thisMission = {
            ID: vm.mission.missionID,
            vibe: vm.vibe,
            complete: true,
            select: 0
        };
        vm.$rootScope.userData.mission.push(thisMission);
        if (vm.$rootScope.userData.taskbook.indexOf(vm.mission.missionID) < 0) {
            vm.$rootScope.userData.taskbook.push(vm.mission.missionID);
        }
        vm.apiService.updateUserData(vm.$rootScope.userData)
            .then(function (res) {
                vm.sound('heart');
                vm.$ionicLoading.hide();
                console.log(res);
                vm.$state.go(route, {}, { reload: true });
            });
    }

    DemoDesController.prototype.nextLine = function () {
        var vm = this;
        vm.lineCount = vm.lineCount + 1;


        if (vm.lineCount < vm.finalDialogue.length) {
            vm.line = vm.finalDialogue[vm.lineCount];

            //處理得到道具
            if (!!vm.line.effect_obj && !!Object.keys(vm.line.effect_obj).length) {

                //vm.$scope.showAlert();
                switch (vm.line.effect_obj.type) {
                    case 'get_item':
                        vm.getItemPopup = true;
                        vm.sound('heart');
                        //[1] 取得此物品的資訊
                        vm.item = vm.allItems[vm.line.effect_obj.targetID];

                        //[2] 回寫到 UserData
                        var checkItem = vm.$rootScope.userData.item.filter(function (item) {
                            return vm.line.effect_obj.targetID === item.ID;
                        });
                        if (checkItem.length > 0) {
                            //物品資訊存在,更新
                            vm.$rootScope.userData.item.forEach(function (item) {
                                if (vm.line.effect_obj.targetID === item.ID) {
                                    item.Count = item.Count + vm.line.effect_obj.count;
                                }
                            });
                        } else {
                            //物品資訊不存在，新增
                            var newItem = {
                                ID: vm.item.ID,//"0001",
                                Count: 1
                            }
                            vm.$rootScope.userData.item.push(newItem);
                        }
                        break;

                    case 'reward':
                        //結局圖
                        var _target = vm.line.effect_obj.target;

                        if (vm.$rootScope.userData.reward.indexOf(_target) < 0) {
                            vm.$rootScope.userData.reward.push(_target);
                        }
                        vm.showReward = true;
                        vm.reward = _target + "_ending.png";
                        break;

                    case 'theme_transition':
                        vm.ThemeTransition = false;
                        vm.$timeout(function () {
                            vm.ThemeTransition = true;
                            vm.nextLine();
                        }, 500);
                        break;

                    case 'update_vibe':
                        var _vibeEffect = vm.line.effect_obj.target;

                        Object.keys(_vibeEffect).forEach(function (name, index) {
                            var value = _vibeEffect[name];
                            vm.$rootScope.userData.vibe[name] += value;
                        });
                        break;
                        
                    case 'mission_complete':
                        vm.getItemPopup = false;
                        vm.missionComplete = true;

                        break;


                }

            } else {
                vm.getItemPopup = false;
            }

            if (vm.line.type === "select") {
                //選項對話
                vm.question = vm.finalDialogue[vm.lineCount - 1].dialogue;
                vm.selectionList = vm.line;
            }

            //處理音效
            vm.sound('conversation');


            console.log(vm.lineCount);
        } else {
            vm.getItemPopup = false;
        }
    }

    DemoDesController.prototype.goFollowing = function (index) {
        var vm = this;
        vm.followingLines = vm.selectionList.select[index].following;
        vm.isFollowing = true;
        vm.following = vm.followingLines[0];
        vm.sound('heart');

        if (!!Object.keys(vm.selectionList.select[index].effect_obj).length && vm.selectionList.select[index].effect_obj.type === 'update_vibe') {
            var _vibeEffect = vm.selectionList.select[index].effect_obj.target;

            Object.keys(_vibeEffect).forEach(function (name, index) {
                var value = _vibeEffect[name];
                vm.$rootScope.userData.vibe[name] += value;
            });

        }

        //處理得到道具
        if (!!vm.following.effect_obj && !!Object.keys(vm.following.effect_obj).length) {

            //vm.$scope.showAlert();
            if (vm.following.effect_obj.type === 'get_item') {
                vm.getItemPopup = true;

                //[1] 取得此物品的資訊
                vm.item = vm.allItems[vm.following.effect_obj.targetID];

                console.log(vm.item);
                //[2] 回寫到 UserData
                var checkItem = vm.$rootScope.userData.item.filter(function (item) {
                    return vm.following.effect_obj.targetID === item.ID;
                });
                if (checkItem.length > 0) {
                    //物品資訊存在,更新
                    vm.$rootScope.userData.item.forEach(function (item) {
                        if (vm.following.effect_obj.targetID === item.ID) {
                            item.Count = item.Count + vm.following.effect_obj.count;
                        }
                    });
                } else {
                    //物品資訊不存在，新增
                    var newItem = {
                        ID: vm.item.ID,//"0001",
                        Count: 1
                    }
                    vm.$rootScope.userData.item.push(newItem);
                }
            } else if (vm.following.effect_obj.type === 'theme_transition') {

                vm.ThemeTransition = false;
                vm.$timeout(function () {
                    vm.ThemeTransition = true;
                    vm.nextFollowing();
                }, 500);

            }
        } else {
            vm.getItemPopup = false;
        }
    }

    DemoDesController.prototype.nextFollowing = function () {
        var vm = this;
        vm.followingCount = vm.followingCount + 1;

        if (vm.followingCount < vm.followingLines.length) {
            vm.following = vm.followingLines[vm.followingCount];


            //處理得到道具
            if (!!vm.following.effect_obj && !!Object.keys(vm.following.effect_obj).length) {

                //vm.$scope.showAlert();
                if (vm.following.effect_obj.type === 'get_item') {
                    vm.getItemPopup = true;
                    vm.sound('heart');
                    //[1] 取得此物品的資訊
                    vm.item = vm.allItems[vm.following.effect_obj.targetID];


                    //[2] 回寫到 UserData
                    var checkItem = vm.$rootScope.userData.item.filter(function (item) {
                        return vm.following.effect_obj.targetID === item.ID;
                    });
                    if (checkItem.length > 0) {
                        //物品資訊存在,更新
                        vm.$rootScope.userData.item.forEach(function (item) {
                            if (vm.following.effect_obj.targetID === item.ID) {
                                item.Count = item.Count + vm.following.effect_obj.count;
                            }
                        });
                    } else {
                        //物品資訊不存在，新增
                        var newItem = {
                            ID: vm.item.ID,//"0001",
                            Count: 1
                        }
                        vm.$rootScope.userData.item.push(newItem);
                    }
                } else if (vm.following.effect_obj.type === 'theme_transition') {

                    vm.ThemeTransition = false;
                    vm.$timeout(function () {
                        vm.ThemeTransition = true;
                        vm.nextFollowing();
                    }, 500);

                }
            } else {
                vm.getItemPopup = false;
            }

            //處理音效
            vm.sound('conversation');



        } else {
            this.nextLine();
            vm.isFollowing = false;
        }
    }

    DemoDesController.prototype.openItemInfo = function ($Parentindex, $index) {
        var vm = this;
        vm.sound('conversation');
        var _index = $Parentindex + $index;
        vm.thisItem = vm.userItems[_index];
        vm.showItemInfo = true;
    }
    DemoDesController.prototype.closeItemInfo = function () {
        var vm = this;
        vm.showItemInfo = false;
    }
    DemoDesController.prototype.exitItemInfo = function () {
        var vm = this;
        vm.randomMissionDialogue = vm.randomMission.select["exit"];
        vm.sound('conversation');
        vm.showItemInfo = false;
        vm.$scope.closeItemModal();
        this.goMainMission();
    }
    DemoDesController.prototype.continueItemInfo = function () {
        var vm = this;
        console.log(vm.thisItem);
        var _key = vm.randomMission.select.hasOwnProperty(vm.thisItem.ID) ? vm.thisItem.ID : "other";

        vm.randomMissionDialogue = vm.randomMission.select[_key];
        vm.sound('heart');

        //道具 -1
        vm.$rootScope.userData.item.forEach(function (i) {
            if (i.ID === vm.thisItem.ID) {
                i.Count = i.Count - 1;
            }
        });
        //改變 vibe
        var _firstDialogue = vm.randomMissionDialogue[0];
        if (!!_firstDialogue.effect_obj && !!Object.keys(_firstDialogue.effect_obj).length) {
            switch (_firstDialogue.effect_obj.type) {
                case 'update_vibe':
                    var _vibeEffect = _firstDialogue.effect_obj.target;

                    Object.keys(_vibeEffect).forEach(function (name, index) {
                        var value = _vibeEffect[name];
                        vm.$rootScope.userData.vibe[name] += value;
                        //event +1
                        vm.$rootScope.userData.event.push({ type: "feed", target: name, item: vm.thisItem.ID });
                    });
                    break;
            }
        }

        vm.showItemInfo = false;
        vm.$scope.closeItemModal();

        this.goMainMission();
    }

    DemoDesController.prototype.sound = function (type) {
        var device = this.$cordovaDevice.getDevice();
        switch (type) {
            case "conversation":
                if (device.platform.toLowerCase() === "android") {
                    app.media.sound_conversation.stop();
                } else {
                    app.media.sound_conversation.pause();
                    app.media.sound_conversation.currentTime = 0;
                }
                app.media.sound_conversation.play();
                break;

            case "heart":
                if (device.platform.toLowerCase() === "android") {
                    app.media.sound_heart.stop();
                } else {
                    app.media.sound_heart.pause();
                    app.media.sound_heart.currentTime = 0;
                }
                app.media.sound_heart.play();
                break;
            case "others":
                if (device.platform.toLowerCase() === "android") {
                    app.media.sound_others.stop();
                } else {
                    app.media.sound_others.pause();
                    app.media.sound_others.currentTime = 0;
                }
                app.media.sound_others.play();
                break;
        }
    }

    DemoDesController.$inject = ['$scope', '$rootScope', '$ionicPlatform', '$state', '$ionicModal', '$ionicLoading', '$cordovaDevice', '$timeout', 'ApiService'];
    angular.module('metro-romance').controller('DemoDesCtrl', DemoDesController);

})();
