// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
(function () {

    function GalleryControllor($scope, $rootScope, $state, $cordovaDevice, $window) {
        var vm = this;
        this.$window = $window;
        this.$cordovaDevice = $cordovaDevice;

        var _data = ["KS_Ann", "KS_Art", "KS_Emilia", "KS_Feiyong", "KS_Nana", "KS_Sora", "TP_AnnEmiliaNanaSora", "TP_ArtFeiyong", "FK_Midori"];

        vm.thisPhoto = "";
        vm.isLarge = false;
        vm.data = _data.map(function (_name) {

            var _hasReward = true;
            if ($rootScope.userData.reward.indexOf(_name) < 0) {
                _hasReward = false;
            }
            var _chapter = _name.substring(0, 2);
            return {
                chapter: _chapter,
                name: _name,
                icon: "gallery-" + _name + "-btn.png",
                photo: _name + "_ending.png",
                collected: _hasReward
            }
        });
    }

    GalleryControllor.prototype.showPhoto = function ($index) {
        var vm = this;
        vm.sound('heart');
        vm.thisPhoto = vm.data[$index].photo;
        vm.thisChapter = vm.data[$index].chapter;
    }

    GalleryControllor.prototype.showDefault = function () {
        var vm = this;
        vm.thisPhoto = "";
        vm.thisChapter = "";
    }

    GalleryControllor.prototype.showLarge = function () {
        var vm = this;
        vm.isLarge = true;
    }

    GalleryControllor.prototype.hideLarge = function () {
        var vm = this;
        vm.isLarge = false;
    }

    GalleryControllor.prototype.goBack = function () {
        this.$window.history.back();
    }

    GalleryControllor.prototype.sound = function (type) {
        var device = this.$cordovaDevice.getDevice();
        switch (type) {
            case "conversation":
                if (device.platform.toLowerCase() === "android") {
                    app.media.sound_conversation.stop();
                } else {
                    app.media.sound_conversation.pause();
                    app.media.sound_conversation.currentTime = 0;
                }
                app.media.sound_conversation.play();
                break;

            case "heart":
                if (device.platform.toLowerCase() === "android") {
                    app.media.sound_heart.stop();
                } else {
                    app.media.sound_heart.pause();
                    app.media.sound_heart.currentTime = 0;
                }
                app.media.sound_heart.play();
                break;
            case "others":
                if (device.platform.toLowerCase() === "android") {
                    app.media.sound_others.stop();
                } else {
                    app.media.sound_others.pause();
                    app.media.sound_others.currentTime = 0;
                }
                app.media.sound_others.play();
                break;
        }
    }

    GalleryControllor.$inject = ['$scope', '$rootScope', '$state', '$cordovaDevice', '$window'];
    angular.module('metro-romance').controller('GalleryCtrl', GalleryControllor);

})();
