// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
(function () {

    function ItemsControllor($scope, $rootScope, $state,$cordovaDevice, $window, $ionicLoading) {

        var vm = this;
        vm.$window = $window;
        vm.$cordovaDevice = $cordovaDevice;

        vm.showItemInfo = false;
        var _allItems = this.indexBy($rootScope.allItems, "ID");

        vm.userItems = $rootScope.userData.item
            .filter(function (i) {
                return i.Count > 0;
            })
            .map(function (i) {
                return Object.assign({},_allItems[i.ID],i);
            });

    }

    ItemsControllor.prototype.openItemInfo = function ($ParentIndex, $index) {
        var vm = this;
        vm.sound('conversation');
        
        var _index = $ParentIndex + $index;
        vm.thisItem = vm.userItems[_index];
        vm.showItemInfo = true;
    }
    ItemsControllor.prototype.closeItemInfo = function ($index) {
        var vm = this;
        vm.showItemInfo = false;
    }
    ItemsControllor.prototype.goBack = function () {
        var vm = this;
        this.$window.history.back();
    }
    ItemsControllor.prototype.indexBy = function (list, iteratee) {
        var result = {};
        list.forEach(function (item) {
            result[item[iteratee]] = item;
        });
        return result;
    }

    ItemsControllor.prototype.sound = function (type) {
        var device = this.$cordovaDevice.getDevice();
        switch (type) {
            case "conversation":
                if (device.platform.toLowerCase() === "android") {
                    app.media.sound_conversation.stop();
                } else {
                    app.media.sound_conversation.pause();
                    app.media.sound_conversation.currentTime = 0;
                }
                app.media.sound_conversation.play();
                break;

            case "heart":
                if (device.platform.toLowerCase() === "android") {
                    app.media.sound_heart.stop();
                } else {
                    app.media.sound_heart.pause();
                    app.media.sound_heart.currentTime = 0;
                }
                app.media.sound_heart.play();
                break;
            case "others":
                if (device.platform.toLowerCase() === "android") {
                    app.media.sound_others.stop();
                } else {
                    app.media.sound_others.pause();
                    app.media.sound_others.currentTime = 0;
                }
                app.media.sound_others.play();
                break;
        }
    }

    ItemsControllor.$inject = ['$scope', '$rootScope', '$state','$cordovaDevice', '$window', '$ionicLoading'];
    angular.module('metro-romance').controller('ItemsCtrl', ItemsControllor);

})();
