// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
(function () {

    function LoginControllor($scope, $rootScope, $state, $window, $ionicLoading, $ionicPopup, apiService) {
        var vm = this;
        this.$state = $state;
        this.$window = $window;
        this.apiService = apiService;
        this.$ionicPopup = $ionicPopup;
        this.$ionicLoading = $ionicLoading;
        this.$rootScope = $rootScope;
    }


    LoginControllor.prototype.fbLogin = function () {
        var vm = this;

        vm.$ionicLoading.show({
            template: 'Loading...',
        });

        if (!window.cordova) {
            facebookConnectPlugin.browserInit("411097852618463");
        }

        facebookConnectPlugin.getLoginStatus(
            function (response) {
                if (response.status != 'connected') {
                    console.log("not logged in yet");
                    facebookConnectPlugin.login([],
                        function (res) {

                            // update user data
                            var fbid = res['authResponse']['userID'];
                            localStorage.setItem('facebookId', fbid);
                            this.updateUserData(fbid);
                            // check pre register
                        }.bind(this),
                        function (res) {
                            vm.$ionicLoading.hide();
                            vm.$ionicPopup.alert({
                                title: '登入失敗',
                                content: '對不起，請確認您的網路與Facebook設定，然後重試。',
                                okText: '確定'
                            });
                            console.log(JSON.stringify(res))
                        }
                    ); //fbLoginSuccess, fbLoginError);

                } else {
                    // logged in and authorized
                    console.log("logged in and authorized");
                    var fbid = response['authResponse']['userID'];
                    localStorage.setItem('facebookId', fbid);
                    // update user data
                    this.updateUserData(fbid);
                }
            }.bind(this),
            function (error) {
                console.log(JSON.stringify(error))
            }
        );
    }


    LoginControllor.prototype.updateUserData = function (fbid) {
        var vm = this;

        vm.apiService.updateUserFB(fbid)
            .then(vm.apiService.checkPreRegister)
            .then(function (res) {
                vm.$ionicLoading.hide();

                var _text = '您的帳號已經與Facebook綁定，謝謝!';
                if (res.data.result === "item added") {
                    _text += "恭喜您得到事前登錄道具「情書」"
                }

                vm.$ionicPopup.alert({
                    title: '登入成功',
                    template: _text,
                    okText: '確定'
                }).then(function (res) {
                    vm.$ionicLoading.show({
                        template: 'Loading...',
                    });
                    vm.apiService.getUserData()
                        .then(function (res2) {
                            vm.$ionicLoading.hide();
                            vm.$rootScope.userData = res2.data.User;
                            vm.$state.go('select', null, { reload: true });
                        });
                });

                console.log(res);
            });
    }


    LoginControllor.prototype.goBack = function () {
        var vm = this;
        this.$window.history.back();
    }


    LoginControllor.$inject = ['$scope', '$rootScope', '$state', '$window', '$ionicLoading', '$ionicPopup', 'ApiService'];
    angular.module('metro-romance').controller('LoginCtrl', LoginControllor);

})();
