// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
(function () {

    function DemoControllor($scope, $sce, $rootScope, $state, $cordovaDevice, $window, $ionicLoading, $ionicModal, $ionicPopup, $cordovaGeolocation, apiService) {
        var vm = this;
        this.$state = $state;
        this.$window = $window;
        this.$scope = $scope;
        this.$rootScope = $rootScope;
        this.$ionicLoading = $ionicLoading;
        this.$cordovaDevice = $cordovaDevice;
        this.$ionicPopup = $ionicPopup;
        this.apiService = apiService;

        $rootScope.arItemPupup = {
            show: false,
            id: "",
            name: ""
        }

        vm.blink = false;
        vm.zoom = 1;
        vm.checkSpecial = this.checkSpecial;
        vm.isResetPopup = false;

        vm.isShowNotificationPopup = false;

        var currentLocation = null;

        var _tickets = vm.userItems = $rootScope.userData.item
            .filter(function (i) {
                return i.ID === "0014";
            });
        vm.ticket = (_tickets.length > 0) ? _tickets[0] : { ID: "0014", Count: 0 };


        vm.scrllStyle = {
            width: $window.innerWidth,
            height: $window.innerHeight
        }

        //舊的 unlock模式 [1]: 把storage 的值變array
        var _storage_unlock = [];
        if (!!localStorage.getItem('locations')) {
            _old_location_info = JSON.parse(localStorage.getItem('locations'));
            _storage_unlock = _old_location_info.filter(function (lo) {
                return lo.unlock;
            }).map(function (lo) {
                return lo.id;
            })
        };

        //舊的 unlock模式 [2]:把 storage的值跟 userData的合併
        var _temp = $rootScope.userData.unlock.concat(_storage_unlock);
        $rootScope.userData.unlock = _temp.filter(function (item, pos) {
            return _temp.indexOf(item) === pos;
        });


        vm.chapter = $rootScope.chapterName;
        var unlock = $rootScope.userData.unlock;
        vm.useTicket = false;
        vm.locations = $rootScope.locations.Location
            .filter(function (lo) {
                return lo.id.indexOf(vm.chapter) === 0
            }).filter(function (lo) {
                return (lo.id !== 'KSL0') && (lo.id !== 'FKL0')
            }).map(function (lo) {
                lo.blink = false;
                lo.unlock = (unlock.indexOf(lo.id) >= 0);
                return lo;
            });

        //這個 _getMission 是private function
        var _getMission = function (location) {
            $ionicLoading.show({
                template: 'Loading...',
            })
            apiService.getMission(location.id, $rootScope.userData)
                .then(function (res) {

                    $ionicLoading.hide();
                    console.log(res.data);
                    $rootScope.output = res.data;

                    if (Object.keys(res.data).length === 0) {
                        console.log('error', res);
                        $scope.openIntroModal(location, true);
                        return false;
                    }
                    if (!!res.data.error) {
                        if (res.data.error == "no mission found") {
                            /* 下一版打開[3]      */
                            if (location.id === "KSL1" || location.id === "TPL1") {
                                localStorage.setItem('ks-locationID', 'FKL4');
                                localStorage.setItem('ks-img', '');
                                vm.showSpecialMissionAlert(location.id);
                            } else {
                                vm.showAlert('新的任務還沒出現，去查看簡訊前往下個景點吧!!');
                            }

                            //vm.showAlert('新的任務還沒出現，去查看簡訊前往下個景點吧!!');//下一版移除[3]
                            return false;
                        } else {
                            console.log('error', res.data);
                            return false
                        }
                    }

                    completeMissionIDList = $rootScope.userData.mission.map(function (mission) {
                        return mission.ID;
                    });


                    //確認特殊條件，
                    if (!vm.checkSpecial(res.data, $rootScope.userData)) {
                        $scope.openIntroModal(location, true);
                        return false;
                    }

                    if (completeMissionIDList.indexOf(res.data.mission.missionID) >= 0) {
                        vm.showAlert("這裡的任務已經完成，去查看簡訊前往下個景點吧!!");
                        //$scope.openIntroModal(lo, true);
                        return false;
                    }

                    //[Production]

                    localStorage.setItem('ks-locationID', location.id);
                    localStorage.setItem('ks-img', $rootScope.output.mission.ARimg);

                    var fk_ar_list = ['FKL4', 'FKL5', 'FKL6'];
                    if (fk_ar_list.indexOf(location.id) >= 0) {
                        vm.$state.go('ks-des', { 'type': 'newUser' });
                        return false;
                    } else {
                        app.loadARchitectFK();
                    }

                    //[for Julie]
                    /*
                    localStorage.setItem('ks-locationID', "KSL11");
                    localStorage.setItem('ks-img', $rootScope.output.mission.ARimg);
            
                    $state.go('ks-des');
                    */
                });
        }

        //如果是來自博多的AR ,從這裡要跳去對話
        var _param = $state.params;
        if (Object.keys(_param).indexOf('from') >= 0) {
            if (_param.from === 'ar') {
                var _lo = vm.locations.filter(function (lo) {
                    return lo.id === _param.id;
                })[0];

                _getMission(_lo);
            }
        }

        // 普通 AR
        $scope.goAR = function (lo) {

            //[Production]
            vm.sound('others');
            if (!lo.blink) {
                $scope.openIntroModal(lo, true);
                return false
            }

            var fk_ar_list = ['FKL4', 'FKL5', 'FKL6'];
            if (fk_ar_list.indexOf(lo.id) >= 0) {
                localStorage.setItem('ks-locationID', lo.id);
                app.loadARchitectFK();
                return false;
            }

            _getMission(lo, $rootScope.userData);

        }


        // .fromTemplateUrl() method
        $scope.targetNotification = {
            message: ""
        };
        $ionicModal.fromTemplateUrl('view_components/popover/location-intro.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function (modal) {
            $scope.introModal = modal;
        });

        $ionicModal.fromTemplateUrl('view_components/popover/notification-list.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function (modal) {
            $scope.notificationModal = modal;
        });

        $scope.openPopover = function ($event, $index) {
            vm.sound('others');
            $scope.targetNotification = $scope.notificationList[$index];
        };

        $scope.openIntroModal = function (lo, special) {
            vm.sound('others');
            vm.targetLocation = lo;

            var fk_ar_list = ['FKL4', 'FKL5', 'FKL6'];
            if (fk_ar_list.indexOf(lo.id) >= 0) {
                localStorage.setItem('ks-locationID', lo.id);
                app.loadARchitectFK();
                return false;
            }

            var GOOGLE_API_KEY = "AIzaSyAk4_SJ6XoiTU_7HJgxWl9ByvQ8kKWf_YI";
            // var  mapurl = "https://www.google.com/maps/embed/v1/view?key=&center=" + lo.lat + "," + lo.lon + "&zoom=15"
            var _searchKey = ($rootScope.chapterName === "FK") ? "博多運河城" : lo.name
            var mapurl = "https://www.google.com/maps/embed/v1/place?key=" + GOOGLE_API_KEY + "&q=" + _searchKey;
            vm.currentMapUrl = $sce.trustAsResourceUrl(mapurl);
            console.log(vm.currentMapUrl);
            if (lo.blink && !special) {

            } else {
                $scope.introModal.show();
            }
        };

        $scope.closeIntroModal = function () {
            $scope.introModal.hide();
        };

        var _vibeValidate = function (_condition, _userData) {
            var _result = _condition.map(function (c) {
                switch (c.type) {
                    case "vibe_value":
                        var _userVibe = _userData.vibe[c.target]; //Feiyong

                        switch (c.operator) {
                            case "greater":
                                return _userVibe >= c.value;  //75
                                break;
                            case "less":
                                return _userVibe < c.value;  //75
                                break;
                            default:
                                return false;
                        }
                        break;

                    case "vibe_character":
                        var _userVibe = _userData.vibe[c.target],
                            _compareVibe = _userData.vibe[c.value]; //Art
                        return _userVibe > _compareVibe;

                        break;

                    case "vibe_all_character":
                        var _userVibe = _userData.vibe[c.target],
                            _compareActs = c.value.split(',');
                        var isMost = true;
                        _compareActs.forEach(function (_act) {
                            isMost = isMost && (_userVibe >= _userData.vibe[_act]);  //大於等於每一個人(含自己)
                        });
                        if (c.operator === "greater") {
                            return isMost;
                        } else {
                            return !isMost;
                        }
                        break;

                    default:
                        return false;
                };
            });

            var _final = _result.reduce(function (pre, now) {
                return pre && now;
            }, true); //有任何一個 condition是false就 回傳 false

            return _final;
        }


        // Notification
        var storage = window.localStorage,
            _checkList = JSON.parse(storage.getItem("krt-store-message-check")); //從storage取出暫存
        if (!_checkList) {
            _checkList = [];
        }
        var _data = JSON.stringify(_checkList);
        storage.setItem("krt-store-message-check", _data);

        var _simpleUserMissionList = $rootScope.userData.mission.map(function (_m) {
            return _m.ID;
        }).filter(function (_name) {
            return (_name.indexOf($rootScope.chapterName) >= 0);
        });

        $scope.notificationList = $rootScope.userData.mission
            .filter(function (mission) {
                return (mission.ID.indexOf($rootScope.chapterName) >= 0);
            }).map(function (userMission) {
                var _empty = {
                    mission: "",
                    locationID: "",
                    locationName: "",
                    character: "",
                    vibe: "",
                    dialogue: ""
                }

                var _thisTips = $rootScope.newMissionTipsList.filter(function (_t) {
                    return _t.mission === userMission.ID && _t.vibe == userMission.vibe
                });

                var targetTip = Object.assign({}, _empty);
                if (_thisTips.length > 1) {
                    if (Object.keys(_thisTips[0].branch_obj).length > 0) {
                        targetTip = _thisTips.filter(function (_t) {
                            var branch = _t.branch_obj;
                            if (branch.type === "branch_mission") {
                                if (branch.complete && _simpleUserMissionList.indexOf(branch.target) >= 0) {
                                    return true;
                                }
                                if (!branch.complete && _simpleUserMissionList.indexOf(branch.target) < 0) {
                                    return true;
                                }
                                return false;
                            } else if (branch.type === "branch_vibe") {
                                var _condition = branch.condition;
                                return _vibeValidate(_condition, $rootScope.userData);
                            }
                        })[0];
                    }
                }

                if (_thisTips.length > 1) {
                    return targetTip;
                } else if (_thisTips.length > 0) {
                    return _thisTips[0];
                } else {
                    return _empty;
                }

            }).map(function (_t) {
                return {
                    missionID: _t.mission,
                    location: _t.locationName,
                    character: _t.character,
                    character_img: _t.character + "-icon.png",
                    message: _t.dialogue,
                    unread: (_checkList.indexOf(_t.mission) < 0)
                }
            }).reverse();

        $scope.unRead = $scope.notificationList.filter(function (n) {
            return n.unread;
        });

        $scope.openNotificationModal = function () {
            vm.sound('others');

            console.log($rootScope.userData.mission);
            $scope.notificationModal.show();
        };

        $scope.closeNotificationModal = function () {
            $scope.notificationModal.hide();
        };

        // Cleanup the modal when we're done with it!
        $scope.$on('$destroy', function () {
            $scope.introModal.remove();
        });
        // Execute action on hide modal
        $scope.$on('modal.hidden', function () {
            // Execute action
        });
        // Execute action on remove modal
        $scope.$on('modal.removed', function () {
            // Execute action
        });

        //---------------------------------------

        $cordovaGeolocation
            .getCurrentPosition({ timeout: 10000, enableHighAccuracy: false })
            .then(function (position) {
                var lati = position.coords.latitude;
                var long = position.coords.longitude;
            }, function (err) {
                $ionicPopup.confirm({
                    title: '沒有GPS訊號',
                    content: '對不起，沒有檢測到GPS訊號。請重新開啟手機定位，然後重試。'
                })
                    .then(function (result) {
                        if (!result) {
                            ionic.Platform.exitApp();
                        }
                    });
            });

        var watchOptions = {
            maximumAge: 5000,
            timeout: 30000,
            enableHighAccuracy: true // may cause errors if true
        };
        var n = 0;

        app.watchPosition = $cordovaGeolocation.watchPosition(watchOptions)

        app.watchPosition.then(
            null,
            function (err) {
                console.log(err);
                // error
            },
            function (position) {

                var lat = position.coords.latitude;
                var lng = position.coords.longitude;
                var acc = position.coords.accuracy;

                if (!vm.useTicket) {
                    if (acc <= 5000) {
                        vm.badSignal = false;
                        apiService.checkLocation(lat, lng, 0.5)// 500公尺
                            .then(function (res) {
                                if (!vm.useTicket) {
                                    var po = res.data.LocationList[0];

                                    vm.locations = vm.locations.map(function (lo) {

                                        if (lo.id === po) {
                                            lo.blink = true;
                                            lo.unlock = true;
                                            if (vm.$rootScope.userData.unlock.indexOf(lo.id) < 0) {
                                                vm.$rootScope.userData.unlock.push(lo.id);
                                                apiService.updateUserData(vm.$rootScope.userData);
                                            }
                                        } else {
                                            lo.blink = false;
                                        }
                                        return lo;
                                    });
                                    var d = new Date();
                                    console.log('success', ++n, d.toTimeString(), lat, lng, acc);

                                    // Successfully retrieved the object. // 若有抓到object代表已進入範圍 -> 地點閃爍
                                    currentLocation = po; // 記得儲存當前地點資訊，之後會要用到。
                                }// if (!vm.useTicket) {

                            });
                    } else {
                        var d = new Date();
                        console.log("GPS訊號強度不佳", d.toTimeString(), lat, lng, acc);
                        vm.badSignal = true;
                        vm.locations = vm.locations.map(function (lo) {
                            lo.blink = false;
                            return lo;
                        });
                    }
                }// if (!vm.useTicket) {

            });// app.watchPosition.then



    }
    DemoControllor.prototype.checkSpecial = function (data, userData) {
        //特殊條件，KSM0018時，KSM0017 高 opened 且 雅朵好感度 >75
        if (data.mission.missionID === "KSM0018") {
            var _case1 = false,
                _case2 = false;
            var _hasMission = userData.mission.filter(function (m) {
                return m.ID === "KSM0017";
            });
            if (_hasMission.length > 0 && _hasMission[0].complete && _hasMission[0].vibe === "High") {
                _case1 = true;
            }
            if (userData.vibe["Art"] > 75) {
                _case2 = true;
            }
            return _case1 && _case2;
        }

        return true;
    }

    DemoControllor.prototype.zone1x = function () {
        var vm = this;
        vm.zoom = 1;
    }
    DemoControllor.prototype.zone2x = function () {
        var vm = this;
        vm.zoom = 2;
    }
    DemoControllor.prototype.zone3x = function () {
        var vm = this;
        vm.zoom = 3;
    }

    DemoControllor.prototype.closeGetItemPopup = function () {
        var vm = this;
        vm.$rootScope.arItemPopup.show = false;
    }

    DemoControllor.prototype.openNotificationPopup = function ($index) {
        var vm = this;
        vm.sound('others');
        vm.targetNotification = vm.$scope.notificationList[$index];
        vm.isShowNotificationPopup = true;

        // Notification 小紅點
        vm.$scope.notificationList[$index].unread = false;
        vm.$scope.unRead = vm.$scope.notificationList.filter(function (n) {
            return n.unread;
        });

        var storage = window.localStorage,
            _checkList = JSON.parse(storage.getItem("krt-store-message-check")); //從storage取出暫存
        if (!_checkList) {
            _checkList = [];
        }
        if (_checkList.indexOf(vm.targetNotification.missionID) < 0) {
            _checkList.push(vm.targetNotification.missionID);
        }
        var _data = JSON.stringify(_checkList);
        storage.setItem("krt-store-message-check", _data);
    }

    DemoControllor.prototype.closeNotificationPopup = function () {
        var vm = this;
        vm.isShowNotificationPopup = false;
    }

    DemoControllor.prototype.showAlert = function (_text) {
        var vm = this;
        var alertPopup = vm.$ionicPopup.alert({
            title: '沒有任務囉',
            template: _text
        });
        /*
        alertPopup.then(function (res) {
            console.log('Thank you for not eating my delicious ice cream cone');
        });
        */
    };

    DemoControllor.prototype.showSpecialMissionAlert = function (id) {
        var vm = this;
        //  if (lo.id === "KSL1" || lo.id === "TPL1") {
        if (id === "KSL1") {
            vm.$scope.specialDescription = "歡迎上「85大樓觀景台」觀賞高雄的無敵海景，並且找尋AR圖標來完成彩蛋任務，獲得特殊道具!!"
        } else if (id === "TPL1") {
            vm.$scope.specialDescription = "歡迎到「閱樂書店」感受文學書香氣息，並且找尋 AR 圖標來完成彩蛋任務，獲得特殊道具！!"
        }
        var myPopup = vm.$ionicPopup.show({
            templateUrl: 'view_components/popover/special-mission.html',
            title: '沒有任務囉',
            scope: vm.$scope,
            buttons: [
                { text: '離開' },
                {
                    text: '<b>前往支線任務</b>',
                    type: 'button-positive',
                    onTap: function (e) {
                        app.loadARchitectFK();
                    }
                }
            ]
        });
        /*
                myPopup.then(function (res) {
                    console.log('Tapped!', res);
                });
        
                vm.$timeout(function () {
                    myPopup.close(); //close the popup after 3 seconds for some reason
                }, 3000);
        */
    };

    DemoControllor.prototype.showConfirmTicket = function () {
        var vm = this;
        var confirmPopup = vm.$ionicPopup.confirm({
            title: '使用車票?',
            template: '使用車票後，點選指定地點。若有任務可以直接開啟。'
        });

        confirmPopup.then(function (res) {
            if (res) {
                //確定使用
                //[1] 先扣一張車票
                vm.$rootScope.userData.item = vm.$rootScope.userData.item.map(function (i) {
                    if (i.ID === "0014") {
                        i.Count = i.Count - 1;
                    }
                    return i
                });

                vm.sound('other');
                //[2] 讓地圖的地點閃爍
                var unlock = vm.$rootScope.userData.unlock;

                vm.useTicket = true;
                vm.locations = vm.$rootScope.locations.Location
                    .filter(function (lo) {
                        return lo.id.indexOf(vm.chapter) === 0
                    }).filter(function (lo) {
                        return (lo.id !== 'KSL0') && (lo.id !== 'FKL0')
                    }).map(function (lo) {
                        lo.blink = true;
                        lo.unlock = (unlock.indexOf(lo.id) >= 0);
                        return lo;
                    });
            } else {
                console.log('cancel');
            }
        });
    };

    DemoControllor.prototype.confirmReset = function () {
        var vm = this;
        vm.sound('others');
        vm.$ionicLoading.show({
            template: 'Loading...',
        });
        vm.$rootScope.userData.mission = [];
        vm.$rootScope.userData.vibe = { Sora: 28, Emilia: 30, Nana: 25, Ann: 27, Art: 30, Feiyong: 32 }
        vm.apiService.updateUserData(vm.$rootScope.userData)
            .then(function (res) {
                vm.sound('heart');
                vm.$ionicLoading.hide();
                console.log(res);
                vm.$scope.notificationModal.hide();
                vm.isResetPopup = false;
                vm.$state.go('select', {}, { location: 'replace' });
            });
        var storage = window.localStorage;
        storage.removeItem("krt-store-message-check");
    }

    DemoControllor.prototype.openResetPopup = function () {
        var vm = this;
        vm.sound('others');
        vm.isResetPopup = true;
    }

    DemoControllor.prototype.closeResetPopup = function () {
        var vm = this;
        vm.isResetPopup = false;
    }

    DemoControllor.prototype.showUseTicketPopup = function () {
        var vm = this;
        vm.sound('other');
        vm.showConfirmTicket();
    }

    DemoControllor.prototype.goDes = function (lo) {
        var vm = this;
        console.log(lo.id);
        vm.$ionicLoading.show({
            template: 'Loading...',
        });
        localStorage.setItem('ks-locationID', lo.id);
        vm.apiService.getMission(lo.id, vm.$rootScope.userData)
            .then(function (res) {
                vm.$ionicLoading.hide();

                if (!!res.data.error) {
                    if (res.data.error == "no mission found") {

                        if (lo.id === "KSL1" || lo.id === "TPL1") {
                            localStorage.setItem('ks-locationID', 'FKL4');
                            localStorage.setItem('ks-img', '');
                            vm.showSpecialMissionAlert(lo.id);
                        } else {
                            vm.showAlert('新的任務還沒出現，去查看簡訊前往下個景點吧!!');
                        }
                        return false;
                    } else {
                        console.log('error', res.data);
                        return false
                    }
                }

                vm.$rootScope.output = res.data;
                vm.sound('heart');
                vm.$state.go('ks-des', { 'type': 'newUser' });
            });
    }

    DemoControllor.prototype.giveUpUseTicket = function () {
        var vm = this;
        vm.useTicket = false;
        vm.$rootScope.userData.item = vm.$rootScope.userData.item.map(function (i) {
            if (i.ID === "0014") {
                i.Count = i.Count + 1;
            }
            return i
        });

    }

    DemoControllor.prototype.goSetting = function () {
        var vm = this;
        if (vm.useTicket) {
            vm.giveUpUseTicket();
        }
        vm.sound('others');
        vm.$state.go('login');
    }

    DemoControllor.prototype.goItems = function () {
        var vm = this;
        if (vm.useTicket) {
            vm.giveUpUseTicket();
        }
        vm.sound('others');
        vm.$state.go('ks-items');
    }

    DemoControllor.prototype.goTaskbook = function () {
        var vm = this;
        if (vm.useTicket) {
            vm.giveUpUseTicket();
        }
        vm.sound('others');
        //vm.$state.go('tabs.taskbook');
        vm.$state.go('ks-taskbook');
    }

    DemoControllor.prototype.goSelect = function () {
        var vm = this;
        if (vm.useTicket) {
            vm.giveUpUseTicket();
        }
        app.watchPosition.clearWatch();
        vm.sound('others');
        vm.$state.go('select');
    }

    DemoControllor.prototype.sound = function (type) {
        var device = this.$cordovaDevice.getDevice();
        switch (type) {
            case "conversation":
                if (device.platform.toLowerCase() === "android") {
                    app.media.sound_conversation.stop();
                } else {
                    app.media.sound_conversation.pause();
                    app.media.sound_conversation.currentTime = 0;
                }
                app.media.sound_conversation.play();
                break;

            case "heart":
                if (device.platform.toLowerCase() === "android") {
                    app.media.sound_heart.stop();
                } else {
                    app.media.sound_heart.pause();
                    app.media.sound_heart.currentTime = 0;
                }
                app.media.sound_heart.play();
                break;
            case "others":
                if (device.platform.toLowerCase() === "android") {
                    app.media.sound_others.stop();
                } else {
                    app.media.sound_others.pause();
                    app.media.sound_others.currentTime = 0;
                }
                app.media.sound_others.play();
                break;
        }
    }



    DemoControllor.prototype.indexBy = function (list, iteratee) {
        var result = {};
        list.forEach(function (item) {
            result[item[iteratee]] = item;
        });
        return result;
    }

    DemoControllor.$inject = ['$scope', '$sce', '$rootScope', '$state', '$cordovaDevice', '$window', '$ionicLoading', '$ionicModal', '$ionicPopup', '$cordovaGeolocation', 'ApiService'];

    angular.module('metro-romance').controller('DemoCtrl', DemoControllor);

})();