// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
(function () {

    function SelectControllor($scope, $rootScope, $state, $cordovaDevice, $ionicLoading, $ionicPopup, $timeout, apiService, $q) {
        /*
              $ionicPlatform.ready(function() {
                app.media.music.play();
              });
        */
        var vm = this;
        this.$rootScope = $rootScope;
        this.$state = $state;
        this.apiService = apiService;
        this.$ionicLoading = $ionicLoading;
        this.$ionicPopup = $ionicPopup;
        this.$cordovaDevice = $cordovaDevice;

        vm.openScreen1 = true;

        $timeout(function () {
            vm.openScreen1 = false;
            window.sessionStorage.setItem('krt-opening', 'true');
        }.bind(this), 5000);//5000

    }

    SelectControllor.prototype.isopen = function () {
        var isopen = window.sessionStorage.getItem('krt-opening');
        return (!isopen) || isopen === 'false';
    }


    SelectControllor.prototype.goSetting = function () {
        var vm = this;
        vm.sound('others');
        if (!vm.$rootScope.userData) {
            this.showAlert();
            return false;
        }
        vm.$state.go('setting');
    }

    SelectControllor.prototype.goItems = function () {
        var vm = this;
        vm.sound('others');
        if (!vm.$rootScope.userData) {
            this.showAlert();
            return false;
        }
        vm.$state.go('ks-items');
    }

    SelectControllor.prototype.goGallery = function () {
        var vm = this;
        vm.sound('others');
        if (!vm.$rootScope.userData) {
            this.showAlert();
            return false;
        }
        vm.$state.go('gallery');
    }

    SelectControllor.prototype.goTutorial = function () {
        var vm = this;
        if (!vm.$rootScope.userData) {
            this.showAlert();
            return false;
        }
        vm.$state.go('tutorial');
    }

    SelectControllor.prototype.goMain = function (chapterName) {
        var vm = this;
        vm.sound('heart');

        vm.$rootScope.chapterName = chapterName;
        vm.$ionicLoading.show({
            template: 'Loading...',
        });

        // vm.apiService.getUserData()
        if (!vm.$rootScope.userData) {
            vm.$ionicLoading.hide();
            this.showAlert();
            return false;
        } else {
            app.changeBackgroundMusic(chapterName);
            switch (chapterName) {
                case "FK":
                    var _iniMission = vm.$rootScope.userData.mission.filter(function (m) {
                        return m.ID === "FKM0001";
                    });
                    if (!!_iniMission.length) {
                        vm.$ionicLoading.hide();
                        vm.$state.go('ks-main');
                    } else {
                        localStorage.setItem('ks-locationID', "FKL0");
                        vm.apiService.getMission("FKL0", vm.$rootScope.userData)
                            .then(function (res) {
                                vm.$ionicLoading.hide();
                                vm.$rootScope.output = res.data;
                                vm.$state.go('ks-des', { 'type': 'newUser' });
                            });
                    }
                    break;
                default:
                    if (!!vm.$rootScope.userData.mission.length) {
                        vm.$ionicLoading.hide();
                        vm.$state.go('ks-main');
                    } else {
                        localStorage.setItem('ks-locationID', "KSL0");
                        vm.apiService.getMission("KSL0", vm.$rootScope.userData)
                            .then(function (res) {
                                vm.$ionicLoading.hide();
                                vm.$rootScope.output = res.data;
                                vm.$state.go('ks-des', { 'type': 'newUser' });
                            });
                    }
                    break;
            }

        }
    }

    SelectControllor.prototype.showAlert = function () {
        var vm = this;
        vm.$ionicPopup.confirm({
            title: '沒有網絡',
            content: '對不起，沒有檢測到網路連接。請重新連接，然後重試。',
            cancelText: '離開遊戲',
            okText: '重新整理'
        })
            .then(function (result) {
                if (!result) {
                    ionic.Platform.exitApp();
                    return false;
                } else {
                    vm.$ionicLoading.show({
                        template: 'Loading...',
                    });

                    app.iniRootScopeData()
                        .then(function (res) {
                            vm.$ionicLoading.hide();
                        }, function (err) {
                            vm.$ionicLoading.hide();
                        });

                }
            });
    }

    SelectControllor.prototype.sound = function (type) {
        var device = this.$cordovaDevice.getDevice();
        switch (type) {
            case "conversation":
                if (device.platform.toLowerCase() === "android") {
                    app.media.sound_conversation.stop();
                } else {
                    app.media.sound_conversation.pause();
                    app.media.sound_conversation.currentTime = 0;
                }
                app.media.sound_conversation.play();
                break;

            case "heart":
                if (device.platform.toLowerCase() === "android") {
                    app.media.sound_heart.stop();
                } else {
                    app.media.sound_heart.pause();
                    app.media.sound_heart.currentTime = 0;
                }
                app.media.sound_heart.play();
                break;
            case "others":
                if (device.platform.toLowerCase() === "android") {
                    app.media.sound_others.stop();
                } else {
                    app.media.sound_others.pause();
                    app.media.sound_others.currentTime = 0;
                }
                app.media.sound_others.play();
                break;
        }
    }

    SelectControllor.$inject = ['$scope', '$rootScope', '$state', '$cordovaDevice', '$ionicLoading', '$ionicPopup', '$timeout', 'ApiService', '$q'];
    angular.module('metro-romance').controller('SelectCtrl', SelectControllor);

})();
