// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
(function () {

    function TaskbookControllor($scope, $rootScope, $state, $ionicModal, $ionicLoading, apiService) {
        var vm = this;
        this.$state = $state;
        this.$rootScope = $rootScope;
        this.$ionicLoading = $ionicLoading;
        this.apiService = apiService;
        this.chapter = $rootScope.chapterName;

        
        var _missionNameArray = $rootScope.newMissionTipsList //取得所有的Task列表
            .map(m => m.mission)
            .filter((val, idx, self) => self.indexOf(val) === idx);

        _missionNameArray = _missionNameArray.sort();

        var missionCards = _missionNameArray
            .filter(card => card.indexOf($rootScope.chapterName) >= 0)
            .map(function (card) {
                return {
                    ID: card,
                    complete: false
                }
            });


        // vm.missions = this.CheckComplete(missionCards, $rootScope.userData.mission);
        vm.missions = this.CheckComplete(missionCards, $rootScope.userData.taskbook);
        /*
            vm.missions = $rootScope.userData.mission.filter(function (mission) {
              return mission.complete;
            });
        */
    }

    TaskbookControllor.prototype.CheckComplete = function (allCards, userCards) {
        allCards.forEach(function (a_card) {
            userCards.forEach(function (u_card) {
                if (a_card.ID === u_card) {
                    a_card.complete = true;
                }
            });
        });
        return allCards;
    }

    TaskbookControllor.prototype.goBack = function () {
        var vm = this;
        vm.$state.go('ks-main', null, { reload: true });
    }

    TaskbookControllor.$inject = ['$scope', '$rootScope', '$state', '$ionicModal', '$ionicLoading', 'ApiService'];

    angular.module('metro-romance').controller('TaskbookCtrl', TaskbookControllor);

})();
