// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
(function () {

    function TutorialControllor($scope, $rootScope, $state, $cordovaDevice, $window, $ionicSlideBoxDelegate) {
        var vm = this;
        this.$window = $window;

        $scope.next = function () {
            $ionicSlideBoxDelegate.next();
        };
        $scope.previous = function () {
            $ionicSlideBoxDelegate.previous();
        };

        // Called each time the slide changes
        $scope.slideChanged = function (index) {
            $scope.slideIndex = index;
        };
    }

    TutorialControllor.prototype.goBack = function () {
        var vm = this;
        this.$window.history.back();
    }

    TutorialControllor.prototype.sound = function (type) {
        var device = this.$cordovaDevice.getDevice();
        switch (type) {
            case "conversation":
                if (device.platform.toLowerCase() === "android") {
                    app.media.sound_conversation.stop();
                } else {
                    app.media.sound_conversation.pause();
                    app.media.sound_conversation.currentTime = 0;
                }
                app.media.sound_conversation.play();
                break;

            case "heart":
                if (device.platform.toLowerCase() === "android") {
                    app.media.sound_heart.stop();
                } else {
                    app.media.sound_heart.pause();
                    app.media.sound_heart.currentTime = 0;
                }
                app.media.sound_heart.play();
                break;
            case "others":
                if (device.platform.toLowerCase() === "android") {
                    app.media.sound_others.stop();
                } else {
                    app.media.sound_others.pause();
                    app.media.sound_others.currentTime = 0;
                }
                app.media.sound_others.play();
                break;
        }
    }

    TutorialControllor.$inject = ['$scope', '$rootScope', '$state', '$cordovaDevice', '$window', '$ionicSlideBoxDelegate'];
    angular.module('metro-romance').controller('TutorialCtrl', TutorialControllor);

})();
